#include "/u/VppSimShared/CommonCode/cppsim_classes.h"
#include "/u/VppSimShared/CommonCode/my_classes_and_functions.h"
#include "vxl_veriuser.h"
#include "veriuser.h"

// global variables
double Ts=1.00000000e-11;
int global_cppsim_mode_flag = 1;
int stop_current_alter_run = 0;

struct VECTOR_LINKED_LIST
   {
   Vector *vec;
   IntVector *ivec;
   struct VECTOR_LINKED_LIST *next;
};
typedef struct VECTOR_LINKED_LIST VECTOR_LINKED_LIST;

struct PROBE_LINKED_LIST
   {
   Probe *probe;
   char name[MAX_CHAR_LENGTH];
   int cur_step, first_step, last_step, enable, cur_step_flag;
   double prev_trig_sig, trigger_val;
   struct PROBE_LINKED_LIST *next;
};
typedef struct PROBE_LINKED_LIST PROBE_LINKED_LIST;

struct PROBE_ELEM
   {
   PROBE_LINKED_LIST *Probe;
   Vector *vec;
   IntVector *ivec;
   int min_elem, max_elem, is_vector_flag;
   double prev_val;
   char node_name[MAX_NODE_NAME_LENGTH];
};
typedef struct PROBE_ELEM PROBE_ELEM;

PROBE_LINKED_LIST *global_probe_linked_list = NULL;
VECTOR_LINKED_LIST *global_vector_linked_list = NULL;

void delete_probe_from_global_list(char *output_filename);
PROBE_LINKED_LIST *retrieve_probe_from_global_list(char *output_filename);
PROBE_LINKED_LIST *init_probe_linked_list_entry(char *output_filename);
PROBE_ELEM *init_probe_elem(char *node_name,PROBE_LINKED_LIST *probe);
int determine_max_min_elem(char *in, char *control_string);

vector_struct *retrieve_vector_from_global_list(int vec_num);
int_vector_struct *int_retrieve_vector_from_global_list(int vec_num);
int add_to_global_vector_list(Vector *in);
int add_to_global_vector_list(IntVector *in);
VECTOR_LINKED_LIST *init_vector_linked_list_entry(Vector *in);
VECTOR_LINKED_LIST *init_vector_linked_list_entry(IntVector *in);

extern "C" int probe_start_sample_cpp_calltf();
extern "C" int probe_start_sample_cpp_misctf(int data, int reason);

extern "C" int probe_end_sample_cpp_calltf();
extern "C" int probe_end_sample_cpp_misctf(int data, int reason);

extern "C" int probe_start_time_cpp_calltf();
extern "C" int probe_start_time_cpp_misctf(int data, int reason);

extern "C" int probe_end_time_cpp_calltf();
extern "C" int probe_end_time_cpp_misctf(int data, int reason);

extern "C" int probe_enable_cpp_calltf();
extern "C" int probe_enable_cpp_misctf(int data, int reason);

extern "C" int probe_trigger_cpp_calltf();
extern "C" int probe_trigger_cpp_misctf(int data, int reason);

extern "C" int probe_node_cpp_calltf();
extern "C" int probe_node_cpp_misctf(int data, int reason);

extern "C" int set_Ts_value_cpp_calltf();
extern "C" int set_Ts_value_cpp_misctf(int data, int reason);

extern "C" int get_vector_elem_cpp_calltf();
extern "C" int get_vector_elem_cpp_misctf(int data, int reason);

extern "C" int get_intvector_elem_cpp_calltf();
extern "C" int get_intvector_elem_cpp_misctf(int data, int reason);

extern "C" int reset_cppsim_modules_cpp_calltf();
extern "C" int reset_cppsim_modules_cpp_misctf(int data, int reason);

extern "C" int update_cppsim_mode_cpp_calltf();
extern "C" int update_cppsim_mode_cpp_misctf(int data, int reason);

class lpf_first_order_cpp
{
public:
  lpf_first_order_cpp(double gain,double fp);
  ~lpf_first_order_cpp();
  void inp(double in_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// static variables
// parameters
  double gain_arg_in;
  double fp_arg_in;
// classes
  Filter filt;
// functions
private:
};

extern "C" int lpf_first_order_cpp_calltf();
extern "C" int lpf_first_order_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class vco_cpp
{
public:
  vco_cpp(double freq,double kvco);
  ~vco_cpp();
  void inp(double vctrl_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double sineout;
  double squareout;
// inputs
  double vctrl;
// static variables
// parameters
  double freq_arg_in;
  double kvco_arg_in;
// classes
  Vco vco;
// functions
private:
};

extern "C" int vco_cpp_calltf();
extern "C" int vco_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

