#include "test_lib.h"

// global variables
int global_pointer_still_NULL_flag;
double Ts=1.00000000e-012;

#include "test_lib.cpp"
#include "c:/CppSim/CommonCode/my_classes_and_functions.cpp"

void main_sim_block(int skew_count);
FILE *fp_counter;

main()
{
if ((fp_counter = fopen("test_progress.counter","w")) == NULL)
   {
   printf("error - can't open file test_progress.counter in write mode\n");
   exit(1);
   }
int skew_count=0;
main_sim_block(skew_count);
fclose(fp_counter);
}

void main_sim_block(int skew_count)
{
int num_sim_steps=100000;
int sim_step;
char out_filename[100];

// Probe statements for 'output: test'
sprintf(out_filename,"test.tr%d",skew_count);
Probe probe0(out_filename,Ts);

// Input nodes

dfe_simple_cpp top;


int sim_step_progress_count = 10000;
int sim_step_progress_count_value = 0;

// pass signal values and vector pointers
// (200 iterations is sufficient for 100 levels of hierarchy)
for (sim_step = 0; sim_step < 200; sim_step++)
   {
   global_pointer_still_NULL_flag = 0;
   top.pass_signals_and_vector_pointers();
   }
if (global_pointer_still_NULL_flag == 1)
    {
    printf("Error:  passing vector pointers failed!\n");
    exit(1);
    }

// run init_output_vectors: code
top.init_output_vectors();

// run init: code
top.init();

// pass init values
// (200 iterations is sufficient for 100 levels of hierarchy)
for (sim_step = 0; sim_step < 200; sim_step++)
   {
   top.pass_init_values();
   }

// main simulation loop
for (sim_step = 0; sim_step < num_sim_steps; sim_step++)
   {
// top module
   if (sim_step > 0)
      top.inp();
   probe0.inp(top.sum_out,"sum_out");
   probe0.inp(top.out_pb1,"out_pb1");
   probe0.inp(top.out_pb2,"out_pb2");
   probe0.inp(top.out_pb3,"out_pb3");
   probe0.inp(top.in,"in");
   probe0.inp(top.clk,"clk");
   probe0.inp(top.edge_ref,"edge_ref");
   probe0.inp(top.edge_out,"edge_out");
   if ((sim_step % sim_step_progress_count) == 0)
      {
      fprintf(fp_counter,"%d %d\n",skew_count,sim_step_progress_count_value++);
      fflush(fp_counter);
      }
  }
printf("\nSimulation Completed for Alter Run %d\n",skew_count);
fflush(stdout);
}
