#include "c:/CppSim/CommonCode/cppsim_classes.h"
#include "c:/CppSim/CommonCode/my_classes_and_functions.h"

class add2_cpp
{
public:
  add2_cpp();
  ~add2_cpp();
  void inp(double in1_arg_in,double in2_arg_in);
  void pass_signals_and_vector_pointers(double in1_arg_in,double in2_arg_in);
  void init();
  void pass_init_values(double in1_arg_in,double in2_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in1;
  double in2;
// static variables
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class constant_cpp
{
public:
  constant_cpp(double consval);
  ~constant_cpp();
  void inp();
  void pass_signals_and_vector_pointers();
  void init();
  void pass_init_values();
  void init_output_vectors();
// outputs
  double out;
// inputs
// static variables
// parameters
  double consval_arg_in;
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class edgemeasure_cpp
{
public:
  edgemeasure_cpp();
  ~edgemeasure_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// static variables
// parameters
// classes
  EdgeMeasure sig_edge;
// functions
private:
};

/////////////////////////////////////////////////////

class gain_cpp
{
public:
  gain_cpp(double gain);
  ~gain_cpp();
  void inp(double a_arg_in);
  void pass_signals_and_vector_pointers(double a_arg_in);
  void init();
  void pass_init_values(double a_arg_in);
  void init_output_vectors();
// outputs
  double y;
// inputs
  double a;
// static variables
// parameters
  double gain_arg_in;
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class inv_cpp
{
public:
  inv_cpp();
  ~inv_cpp();
  void inp(double a_arg_in);
  void pass_signals_and_vector_pointers(double a_arg_in);
  void init();
  void pass_init_values(double a_arg_in);
  void init_output_vectors();
// outputs
  double y;
// inputs
  double a;
// static variables
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class limitamp_cpp
{
public:
  limitamp_cpp();
  ~limitamp_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// static variables
  double prev_in;
  int state;
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class mux2_cpp
{
public:
  mux2_cpp();
  ~mux2_cpp();
  void inp(double in0_arg_in,double in1_arg_in,double sel_arg_in);
  void pass_signals_and_vector_pointers(double in0_arg_in,double in1_arg_in,double sel_arg_in);
  void init();
  void pass_init_values(double in0_arg_in,double in1_arg_in,double sel_arg_in);
  void init_output_vectors();
// outputs
  double y;
// inputs
  double in0;
  double in1;
  double sel;
// static variables
  double yz;
  int x1;
  List l1;
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class rcfilter_cpp
{
public:
  rcfilter_cpp(double fo);
  ~rcfilter_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// static variables
// parameters
  double fo_arg_in;
// classes
  Filter filt;
// functions
private:
};

/////////////////////////////////////////////////////

class signal_source_cpp
{
public:
  signal_source_cpp(int stype,double freq);
  ~signal_source_cpp();
  void inp(double phase_arg_in);
  void pass_signals_and_vector_pointers(double phase_arg_in);
  void init();
  void pass_init_values(double phase_arg_in);
  void init_output_vectors();
// outputs
  double out;
  double clk;
// inputs
  double phase;
// static variables
// parameters
  int stype_arg_in;
  double freq_arg_in;
// classes
  SigGen siggen1;
  List list1;
// functions
private:
};

/////////////////////////////////////////////////////

class sub2_cpp
{
public:
  sub2_cpp();
  ~sub2_cpp();
  void inp(double in1_arg_in,double in2_arg_in);
  void pass_signals_and_vector_pointers(double in1_arg_in,double in2_arg_in);
  void init();
  void pass_init_values(double in1_arg_in,double in2_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in1;
  double in2;
// static variables
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class trline_load2_cpp
{
public:
  trline_load2_cpp(double zol,double zor,double c1,double sim_order,double c2,double l);
  ~trline_load2_cpp();
  void inp(double eil_arg_in);
  void pass_signals_and_vector_pointers(double eil_arg_in);
  void init();
  void pass_init_values(double eil_arg_in);
  void init_output_vectors();
// outputs
  double out;
  double erl;
// inputs
  double eil;
// static variables
// parameters
  double zol_arg_in;
  double zor_arg_in;
  double c1_arg_in;
  double sim_order_arg_in;
  double c2_arg_in;
  double l_arg_in;
// classes
  Filter Gamma_l;
  Filter Line2Out;
// functions
private:
};

/////////////////////////////////////////////////////

class trline_section_cpp
{
public:
  trline_section_cpp(double delay,double gain,double sim_order);
  ~trline_section_cpp();
  void inp(double eil_arg_in,double eir_arg_in);
  void pass_signals_and_vector_pointers(double eil_arg_in,double eir_arg_in);
  void init();
  void pass_init_values(double eil_arg_in,double eir_arg_in);
  void init_output_vectors();
// outputs
  double err;
  double erl;
  double erl_p;
// inputs
  double eil;
  double eir;
// static variables
// parameters
  double delay_arg_in;
  double gain_arg_in;
  double sim_order_arg_in;
// classes
  Filter delayr;
  Filter delayl;
  Filter delayx;
// functions
private:
};

/////////////////////////////////////////////////////

class vco_cpp
{
public:
  vco_cpp(double freq,double kvco);
  ~vco_cpp();
  void inp(double vctrl_arg_in);
  void pass_signals_and_vector_pointers(double vctrl_arg_in);
  void init();
  void pass_init_values(double vctrl_arg_in);
  void init_output_vectors();
// outputs
  double squareout;
  double sineout;
// inputs
  double vctrl;
// static variables
// parameters
  double freq_arg_in;
  double kvco_arg_in;
// classes
  Vco vco;
// functions
private:
};

/////////////////////////////////////////////////////

class xor2_cpp
{
public:
  xor2_cpp();
  ~xor2_cpp();
  void inp(double a_arg_in,double b_arg_in);
  void pass_signals_and_vector_pointers(double a_arg_in,double b_arg_in);
  void init();
  void pass_init_values(double a_arg_in,double b_arg_in);
  void init_output_vectors();
// outputs
  double y;
// inputs
  double a;
  double b;
// static variables
// parameters
// classes
  Xor xor1;
// functions
private:
};

/////////////////////////////////////////////////////

class fixed_delay_cpp
{
public:
  fixed_delay_cpp(double delay);
  ~fixed_delay_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// static variables
// parameters
  double delay_arg_in;
// classes
  Delay delay2;
// functions
private:
};

/////////////////////////////////////////////////////

class link_channel_cpp
{
public:
  link_channel_cpp();
  ~link_channel_cpp();
  void inp(double channel_in_arg_in);
  void pass_signals_and_vector_pointers(double channel_in_arg_in);
  void init();
  void pass_init_values(double channel_in_arg_in);
  void init_output_vectors();
// outputs
  double channel_out;
// inputs
  double channel_in;
// static variables
// parameters
// classes
  List channel_taps;
  Filter filt_ch;
// functions
private:
};

/////////////////////////////////////////////////////

class nonlin_amp_cpp
{
public:
  nonlin_amp_cpp(double a0,double a1,double a2,double a3,double min,double max);
  ~nonlin_amp_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// static variables
// parameters
  double a0_arg_in;
  double a1_arg_in;
  double a2_arg_in;
  double a3_arg_in;
  double min_arg_in;
  double max_arg_in;
// classes
  Amp amp;
// functions
private:
};

/////////////////////////////////////////////////////

class regen_latch_cpp
{
public:
  regen_latch_cpp(double gain,double f_bw);
  ~regen_latch_cpp();
  void inp(double d_arg_in,double clk_arg_in);
  void pass_signals_and_vector_pointers(double d_arg_in,double clk_arg_in);
  void init();
  void pass_init_values(double d_arg_in,double clk_arg_in);
  void init_output_vectors();
// outputs
  double q;
// inputs
  double d;
  double clk;
// static variables
  int flag;
  double step_gain;
// parameters
  double gain_arg_in;
  double f_bw_arg_in;
// classes
  Filter filt_amp;
  EdgeDetect pos_edge;
  EdgeDetect neg_edge;
// functions
private:
};

/////////////////////////////////////////////////////

class trline_source_impedance_cpp
{
public:
  trline_source_impedance_cpp(double zo,double zor,double amp,double offset,double sim_order);
  ~trline_source_impedance_cpp();
  void inp(double in_arg_in,double outr_p_arg_in,double outr_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in,double outr_p_arg_in,double outr_arg_in);
  void init();
  void pass_init_values(double in_arg_in,double outr_p_arg_in,double outr_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
  double outr_p;
  double outr;
// static variables
// parameters
  double zo_arg_in;
  double zor_arg_in;
  double amp_arg_in;
  double offset_arg_in;
  double sim_order_arg_in;
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class trline_sub_cpp
{
public:
  trline_sub_cpp(double sim_order);
  ~trline_sub_cpp();
  void inp(double in1_arg_in,double in2_arg_in);
  void pass_signals_and_vector_pointers(double in1_arg_in,double in2_arg_in);
  void init();
  void pass_init_values(double in1_arg_in,double in2_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in1;
  double in2;
// classes
  sub2_cpp xi0;
// internal nodes
private:
};

/////////////////////////////////////////////////////

class jitter_edgemeasure_cpp
{
public:
  jitter_edgemeasure_cpp();
  ~jitter_edgemeasure_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// classes
  limitamp_cpp xi0;
  edgemeasure_cpp xi1;
// internal nodes
  double n0;
private:
};

/////////////////////////////////////////////////////

class regen_flipflop_cpp
{
public:
  regen_flipflop_cpp(double gain,double f_bw);
  ~regen_flipflop_cpp();
  void inp(double clk_arg_in,double d_arg_in);
  void pass_signals_and_vector_pointers(double clk_arg_in,double d_arg_in);
  void init();
  void pass_init_values(double clk_arg_in,double d_arg_in);
  void init_output_vectors();
// outputs
  double q;
// inputs
  double clk;
  double d;
// classes
  inv_cpp xi2;
  regen_latch_cpp xi0;
  regen_latch_cpp xi1;
// internal nodes
  double n0;
  double n1;
private:
};

/////////////////////////////////////////////////////

class channel_model_cpp
{
public:
  channel_model_cpp(double k,double fp1,double fp2,double fp3);
  ~channel_model_cpp();
  void inp(double in_arg_in,double inb_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in,double inb_arg_in);
  void init();
  void pass_init_values(double in_arg_in,double inb_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
  double inb;
// classes
  rcfilter_cpp xi2;
  rcfilter_cpp xi0;
  rcfilter_cpp xi1;
  gain_cpp xi3;
  rcfilter_cpp xi4;
  rcfilter_cpp xi5;
  rcfilter_cpp xi6;
  gain_cpp xi7;
  sub2_cpp xi8;
// internal nodes
  double n2;
  double n0;
  double n1;
  double n6;
  double n5;
  double n3;
  double n4;
  double n7;
private:
};

/////////////////////////////////////////////////////

class differential_to_digital_cpp
{
public:
  differential_to_digital_cpp();
  ~differential_to_digital_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// classes
  add2_cpp xi0;
  gain_cpp xi1;
  constant_cpp xi2;
// internal nodes
  double n1;
  double n0;
private:
};

/////////////////////////////////////////////////////

class analog_summer_cpp
{
public:
  analog_summer_cpp(double a0,double a1,double a2,double a3,double h1,double h2,double h3,double bw,double h4,double h5);
  ~analog_summer_cpp();
  void inp(double in_arg_in,double h1_arg_in,double h2_arg_in,double h3_arg_in,double h4_arg_in,double h5_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in,double h1_arg_in,double h2_arg_in,double h3_arg_in,double h4_arg_in,double h5_arg_in);
  void init();
  void pass_init_values(double in_arg_in,double h1_arg_in,double h2_arg_in,double h3_arg_in,double h4_arg_in,double h5_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
  double h1;
  double h2;
  double h3;
  double h4;
  double h5;
// classes
  rcfilter_cpp xi3;
  nonlin_amp_cpp xi4;
  sub2_cpp xi0;
  sub2_cpp xi1;
  sub2_cpp xi2;
  sub2_cpp xi8;
  sub2_cpp xi9;
  gain_cpp xi5;
  gain_cpp xi6;
  gain_cpp xi10;
  gain_cpp xi7;
  gain_cpp xi11;
// internal nodes
  double n1;
  double n0;
  double n9;
  double n10;
  double n7;
  double n8;
  double n5;
  double n6;
  double n3;
  double n4;
  double n2;
private:
};

/////////////////////////////////////////////////////

class channel_model_trline_cpp
{
public:
  channel_model_trline_cpp(double amplitude,double delay,double offset,double zo,double zs,double zl,double c1,double c2,double l,double loss);
  ~channel_model_trline_cpp();
  void inp(double in_arg_in,double inb_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in,double inb_arg_in);
  void init();
  void pass_init_values(double in_arg_in,double inb_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
  double inb;
// classes
  trline_source_impedance_cpp xi2;
  trline_source_impedance_cpp xi4;
  trline_section_cpp xi1;
  trline_section_cpp xi3;
  trline_load2_cpp xi0;
  trline_load2_cpp xi5;
  trline_sub_cpp xi6;
// internal nodes
  double n2;
  double n0;
  double n1;
  double n8;
  double n6;
  double n7;
  double n3;
  double n4;
  double n9;
  double n10;
  double n5;
  double n11;
private:
};

/////////////////////////////////////////////////////

class tap_calibration_cpp
{
public:
  tap_calibration_cpp(double tsym,double clk_delay,double amplitude,double sel);
  ~tap_calibration_cpp();
  void inp();
  void pass_signals_and_vector_pointers();
  void init();
  void pass_init_values();
  void init_output_vectors();
// outputs
  double clk_out;
  double out;
  double outb;
  double out_diff;
// inputs
// classes
  constant_cpp xi1;
  vco_cpp xi4;
  fixed_delay_cpp xi2;
  xor2_cpp xi3;
  vco_cpp xi0;
  fixed_delay_cpp xi7;
  mux2_cpp xi6;
  gain_cpp xi8;
  signal_source_cpp xi5;
  constant_cpp xi12;
  differential_to_digital_cpp xi13;
  gain_cpp xi14;
  differential_to_digital_cpp xi15;
  gain_cpp xi16;
// internal nodes
  double n0;
  double n1;
  double n8;
  double edge2;
  double edge1;
  double n3;
  double n9;
  double n2;
  double n4;
  double n5;
  double n10;
  double n6;
  double n7;
private:
};

/////////////////////////////////////////////////////

class dfe_simple_cpp
{
public:
  dfe_simple_cpp();
  ~dfe_simple_cpp();
  void inp();
  void pass_signals_and_vector_pointers();
  void init();
  void pass_init_values();
  void init_output_vectors();
// outputs
// inputs
// classes
  channel_model_cpp xi5;
  regen_flipflop_cpp xi0;
  regen_flipflop_cpp xi2;
  regen_flipflop_cpp xi3;
  regen_flipflop_cpp xi4;
  regen_flipflop_cpp xi8;
  jitter_edgemeasure_cpp xi7;
  jitter_edgemeasure_cpp xi9;
  analog_summer_cpp xi1;
  channel_model_trline_cpp xi10;
  tap_calibration_cpp xi6;
  link_channel_cpp xi11;
  link_channel_cpp xi12;
  sub2_cpp xi13;
// internal nodes
  double n1;
  double n5;
  double n2;
  double clk;
  double sum_out;
  double out_pb1;
  double out_pb2;
  double out_pb3;
  double out_pb4;
  double out_pb5;
  double edge_out;
  double n0;
  double edge_ref;
  double in;
  double n6;
  double n4;
  double n3;
private:
};

/////////////////////////////////////////////////////

