#include "/home/sanquan/vault/software/VppSimShared/CommonCode/cppsim_classes.h"
#include "/home/sanquan/vault/software/VppSimShared/CommonCode/my_classes_and_functions.h"

//////////////////////////////////////////////////

class vpp_internal_int_to_double_convert_cpp
{
public:
  vpp_internal_int_to_double_convert_cpp();
  ~vpp_internal_int_to_double_convert_cpp();
  void inp(int in_arg_in);
  void pass_signals_and_vector_pointers(int in_arg_in);
  void init();
  void pass_init_values(int in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  int in;
// static variables
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class vpp_internal_double_to_int_convert_cpp
{
public:
  vpp_internal_double_to_int_convert_cpp();
  ~vpp_internal_double_to_int_convert_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  int out;
// inputs
  double in;
// static variables
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class vpp_internal_double_interp_to_int_convert_cpp
{
public:
  vpp_internal_double_interp_to_int_convert_cpp();
  ~vpp_internal_double_interp_to_int_convert_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  int out;
// inputs
  double in;
// static variables
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class err_counter_cpp
{
public:
  err_counter_cpp(int ratio);
  ~err_counter_cpp();
  void inp(double clk_arg_in,double tx_data_arg_in,double rx_data_arg_in);
  void pass_signals_and_vector_pointers(double clk_arg_in,double tx_data_arg_in,double rx_data_arg_in);
  void init();
  void pass_init_values(double clk_arg_in,double tx_data_arg_in,double rx_data_arg_in);
  void init_output_vectors();
// outputs
  double del;
  double ber;
  int counter;
// inputs
  double clk;
  double tx_data;
  double rx_data;
// static variables
  int counter_limit;
  int counter_head;
  int error;
  int error2;
  int del_step;
  long num;
  int sgn;
  int phase_max;
  int phase_min;
  int numTest;
  FILE *fber;
// parameters
  int ratio_arg_in;
// classes
  EdgeDetect pos_edge;
  Delay delay_tx;
  Delay delay;
  Delay delay_clk;
// functions
private:
};

/////////////////////////////////////////////////////

class constant_cpp
{
public:
  constant_cpp(double consval);
  ~constant_cpp();
  void inp();
  void pass_signals_and_vector_pointers();
  void init();
  void pass_init_values();
  void init_output_vectors();
// outputs
  double out;
// inputs
// static variables
// parameters
  double consval_arg_in;
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class delay_sample_scalar_cpp
{
public:
  delay_sample_scalar_cpp(int delay);
  ~delay_sample_scalar_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// static variables
// parameters
  int delay_arg_in;
// classes
  Filter filt;
// functions
private:
};

/////////////////////////////////////////////////////

class eq_setting_from_file_cpp
{
public:
  eq_setting_from_file_cpp(int num_tap);
  ~eq_setting_from_file_cpp();
  void inp();
  void pass_signals_and_vector_pointers();
  void init();
  void pass_init_values();
  void init_output_vectors();
// outputs
  Vector vec_out;
// inputs
// static variables
// parameters
  int num_tap_arg_in;
// classes
  List list1;
// functions
private:
};

/////////////////////////////////////////////////////

class tx_eq_cpp
{
public:
  tx_eq_cpp();
  ~tx_eq_cpp();
  void inp(double clk_in_arg_in,double data_in_arg_in);
  void pass_signals_and_vector_pointers(const Vector &eq_settings_vec_arg_in,double clk_in_arg_in,double data_in_arg_in);
  void init();
  void pass_init_values(double clk_in_arg_in,double data_in_arg_in);
  void init_output_vectors();
// outputs
  double tx_eq_out;
// inputs
  Vector eq_settings_vec;
  vector_struct *eq_settings_vec_struct_hold;
  double clk_in;
  double data_in;
// static variables
// parameters
// classes
  Filter filt_eq;
  EdgeDetect neg_edge;
  List eq_tap_list;
// functions
private:
};

/////////////////////////////////////////////////////

class signal_source_cpp
{
public:
  signal_source_cpp(double freq,int stype);
  ~signal_source_cpp();
  void inp(double phase_arg_in);
  void pass_signals_and_vector_pointers(double phase_arg_in);
  void init();
  void pass_init_values(double phase_arg_in);
  void init_output_vectors();
// outputs
  double clk;
  double out;
// inputs
  double phase;
// static variables
// parameters
  double freq_arg_in;
  int stype_arg_in;
// classes
  SigGen siggen1;
  List list1;
// functions
private:
};

/////////////////////////////////////////////////////

class cdr_counter_cpp
{
public:
  cdr_counter_cpp(int range);
  ~cdr_counter_cpp();
  void inp(double clk_arg_in,double enable_b_arg_in,double inc_dec_arg_in);
  void pass_signals_and_vector_pointers(double clk_arg_in,double enable_b_arg_in,double inc_dec_arg_in);
  void init();
  void pass_init_values(double clk_arg_in,double enable_b_arg_in,double inc_dec_arg_in);
  void init_output_vectors();
// outputs
  int count;
// inputs
  double clk;
  double enable_b;
  double inc_dec;
// static variables
// parameters
  int range_arg_in;
// classes
  EdgeDetect pos_edge;
  Delay delay_clk;
  Probe probe1;
// functions
private:
};

/////////////////////////////////////////////////////

class divider_ideal_cpp
{
public:
  divider_ideal_cpp();
  ~divider_ideal_cpp();
  void inp(double div_val_arg_in,double in_arg_in);
  void pass_signals_and_vector_pointers(double div_val_arg_in,double in_arg_in);
  void init();
  void pass_init_values(double div_val_arg_in,double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double div_val;
  double in;
// static variables
// parameters
// classes
  Divider div1;
// functions
private:
};

/////////////////////////////////////////////////////

class phase_interpolator_cpp
{
public:
  phase_interpolator_cpp(int num_phases,double clk_freq);
  ~phase_interpolator_cpp();
  void inp(double clk_arg_in,int phase_select_arg_in);
  void pass_signals_and_vector_pointers(double clk_arg_in,int phase_select_arg_in);
  void init();
  void pass_init_values(double clk_arg_in,int phase_select_arg_in);
  void init_output_vectors();
// outputs
  double clk_edge;
  double clk_data;
  double clk_adapt;
// inputs
  double clk;
  int phase_select;
// static variables
// parameters
  int num_phases_arg_in;
  double clk_freq_arg_in;
// classes
  Delay delay_data;
  Delay delay_edge;
  Delay delay_adapt;
// functions
private:
};

/////////////////////////////////////////////////////

class cdr_maj_vote_cpp
{
public:
  cdr_maj_vote_cpp(int num_maj_votes);
  ~cdr_maj_vote_cpp();
  void inp(double div_clk_arg_in,double clk_arg_in,double valid_transition_arg_in,double early_late_arg_in);
  void pass_signals_and_vector_pointers(double div_clk_arg_in,double clk_arg_in,double valid_transition_arg_in,double early_late_arg_in);
  void init();
  void pass_init_values(double div_clk_arg_in,double clk_arg_in,double valid_transition_arg_in,double early_late_arg_in);
  void init_output_vectors();
// outputs
  double hold;
  double up_down;
// inputs
  double div_clk;
  double clk;
  double valid_transition;
  double early_late;
// static variables
// parameters
  int num_maj_votes_arg_in;
// classes
  Filter maj_filter;
  EdgeDetect pos_edge1;
  EdgeDetect pos_edge2;
  List filter_tap_list;
// functions
private:
};

/////////////////////////////////////////////////////

class xor2_cpp
{
public:
  xor2_cpp();
  ~xor2_cpp();
  void inp(double a_arg_in,double b_arg_in);
  void pass_signals_and_vector_pointers(double a_arg_in,double b_arg_in);
  void init();
  void pass_init_values(double a_arg_in,double b_arg_in);
  void init_output_vectors();
// outputs
  double y;
// inputs
  double a;
  double b;
// static variables
// parameters
// classes
  Xor xor1;
// functions
private:
};

/////////////////////////////////////////////////////

class inv_cpp
{
public:
  inv_cpp();
  ~inv_cpp();
  void inp(double a_arg_in);
  void pass_signals_and_vector_pointers(double a_arg_in);
  void init();
  void pass_init_values(double a_arg_in);
  void init_output_vectors();
// outputs
  double y;
// inputs
  double a;
// static variables
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class latch1_cpp
{
public:
  latch1_cpp();
  ~latch1_cpp();
  void inp(double latch_arg_in,double d_arg_in);
  void pass_signals_and_vector_pointers(double latch_arg_in,double d_arg_in);
  void init();
  void pass_init_values(double latch_arg_in,double d_arg_in);
  void init_output_vectors();
// outputs
  double q;
// inputs
  double latch;
  double d;
// static variables
// parameters
// classes
  Latch lat1;
// functions
private:
};

/////////////////////////////////////////////////////

class limitamp_cpp
{
public:
  limitamp_cpp();
  ~limitamp_cpp();
  void inp(double in_arg_in);
  void pass_signals_and_vector_pointers(double in_arg_in);
  void init();
  void pass_init_values(double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// static variables
  double prev_in;
  int state;
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class sub2_cpp
{
public:
  sub2_cpp();
  ~sub2_cpp();
  void inp(double in2_arg_in,double in1_arg_in);
  void pass_signals_and_vector_pointers(double in2_arg_in,double in1_arg_in);
  void init();
  void pass_init_values(double in2_arg_in,double in1_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in2;
  double in1;
// static variables
// parameters
// classes
// functions
private:
};

/////////////////////////////////////////////////////

class sampler_cpp
{
public:
  sampler_cpp();
  ~sampler_cpp();
  void inp(double clk_arg_in,double in_arg_in);
  void pass_signals_and_vector_pointers(double clk_arg_in,double in_arg_in);
  void init();
  void pass_init_values(double clk_arg_in,double in_arg_in);
  void init_output_vectors();
// outputs
  double out;
// inputs
  double clk;
  double in;
// static variables
  double prev_in;
// parameters
// classes
  EdgeDetect rising_edge;
// functions
private:
};

/////////////////////////////////////////////////////

class link_channel_cpp
{
public:
  link_channel_cpp();
  ~link_channel_cpp();
  void inp(double channel_in_arg_in);
  void pass_signals_and_vector_pointers(double channel_in_arg_in);
  void init();
  void pass_init_values(double channel_in_arg_in);
  void init_output_vectors();
// outputs
  double channel_out;
// inputs
  double channel_in;
// static variables
// parameters
// classes
  List channel_taps;
  Filter filt_ch;
// functions
private:
};

/////////////////////////////////////////////////////

class dff2_cpp
{
public:
  dff2_cpp();
  ~dff2_cpp();
  void inp(double clk_arg_in,double d_arg_in);
  void pass_signals_and_vector_pointers(double clk_arg_in,double d_arg_in);
  void init();
  void pass_init_values(double clk_arg_in,double d_arg_in);
  void init_output_vectors();
// outputs
  double qb;
  double q;
// inputs
  double clk;
  double d;
// classes
  inv_cpp xi17;
  inv_cpp xi14;
  latch1_cpp xi20;
  latch1_cpp xi19;
// internal nodes
  double net26;
  double net019;
private:
};

/////////////////////////////////////////////////////

class rx_samp_cpp
{
public:
  rx_samp_cpp();
  ~rx_samp_cpp();
  void inp(double threshold_arg_in,double rx_clk_in_arg_in,double rx_samp_in_arg_in);
  void pass_signals_and_vector_pointers(double threshold_arg_in,double rx_clk_in_arg_in,double rx_samp_in_arg_in);
  void init();
  void pass_init_values(double threshold_arg_in,double rx_clk_in_arg_in,double rx_samp_in_arg_in);
  void init_output_vectors();
// outputs
  double rx_samp_out;
// inputs
  double threshold;
  double rx_clk_in;
  double rx_samp_in;
// classes
  limitamp_cpp xi2;
  sub2_cpp xi1;
  sampler_cpp xi0;
// internal nodes
  double samp_out;
  double net17;
private:
};

/////////////////////////////////////////////////////

class link_tx_precoder_cpp
{
public:
  link_tx_precoder_cpp(double symbol_freq,double trigger_freq,double eq_tap_length);
  ~link_tx_precoder_cpp();
  void inp();
  void pass_signals_and_vector_pointers();
  void init();
  void pass_init_values();
  void init_output_vectors();
// outputs
  double tx_data_out;
  double tx_out;
// inputs
// classes
  eq_setting_from_file_cpp xi30;
  tx_eq_cpp xi29;
  signal_source_cpp xi23;
  constant_cpp xi0;
// internal nodes
  Vector net10;
  double net17;
  double net18;
private:
};

/////////////////////////////////////////////////////

class cdr_logic_cpp
{
public:
  cdr_logic_cpp();
  ~cdr_logic_cpp();
  void inp(double cdrdata_arg_in,double clk_data_arg_in,double cdredge_arg_in);
  void pass_signals_and_vector_pointers(double cdrdata_arg_in,double clk_data_arg_in,double cdredge_arg_in);
  void init();
  void pass_init_values(double cdrdata_arg_in,double clk_data_arg_in,double cdredge_arg_in);
  void init_output_vectors();
// outputs
  double early_late;
  double valid_transition;
// inputs
  double cdrdata;
  double clk_data;
  double cdredge;
// classes
  xor2_cpp xi6;
  xor2_cpp xi5;
  inv_cpp xi4;
  dff2_cpp xi3;
  dff2_cpp xi2;
  dff2_cpp xi1;
  dff2_cpp xi0;
// internal nodes
  double net48;
  double net31;
  double net52;
  double net34;
  double net35;
  double net27;
  double net28;
  double net26;
  double net51;
private:
};

/////////////////////////////////////////////////////

class cdr_cpp
{
public:
  cdr_cpp(double clk_freq,double num_maj_votes,double num_cdr_phases);
  ~cdr_cpp();
  void inp(double rx_edge_arg_in,double rx_data_arg_in);
  void pass_signals_and_vector_pointers(double rx_edge_arg_in,double rx_data_arg_in);
  void init();
  void pass_init_values(double rx_edge_arg_in,double rx_data_arg_in);
  void init_output_vectors();
// outputs
  double clk_edge;
  double clk_data;
  double clk_adapt;
// inputs
  double rx_edge;
  double rx_data;
// classes
  cdr_counter_cpp xi6;
  signal_source_cpp xi13;
  divider_ideal_cpp xi11;
  constant_cpp xi10;
  constant_cpp xi12;
  phase_interpolator_cpp xi8;
  cdr_maj_vote_cpp xi5;
  cdr_logic_cpp xi1;
// internal nodes
  double net46;
  double net47;
  int phase;
  double net49;
  double net27;
  double net26;
  double clkref;
  double net34;
  double net52;
  double net53;
private:
};

/////////////////////////////////////////////////////

class link_rx_cpp
{
public:
  link_rx_cpp(double num_cdr_phases,double num_maj_votes,double symbol_freq);
  ~link_rx_cpp();
  void inp(double threshold_adapt_arg_in,double rx_in_arg_in);
  void pass_signals_and_vector_pointers(double threshold_adapt_arg_in,double rx_in_arg_in);
  void init();
  void pass_init_values(double threshold_adapt_arg_in,double rx_in_arg_in);
  void init_output_vectors();
// outputs
  double rx_edge_out;
  double rx_data_out;
  double rx_clk;
  double rx_adapt_out;
// inputs
  double threshold_adapt;
  double rx_in;
// classes
  cdr_cpp xi8;
  constant_cpp xi6;
  constant_cpp xi5;
  rx_samp_cpp xi2;
  rx_samp_cpp xi1;
  rx_samp_cpp xi0;
// internal nodes
  double a38;
  double a46;
  double a40;
  double a44;
private:
};

/////////////////////////////////////////////////////

class link_top_cpp
{
public:
  link_top_cpp();
  ~link_top_cpp();
  void inp();
  void pass_signals_and_vector_pointers();
  void init();
  void pass_init_values();
  void init_output_vectors();
// outputs
// inputs
// classes
  err_counter_cpp xi31;
  constant_cpp xi30;
  delay_sample_scalar_cpp xi23;
  link_tx_precoder_cpp xi12;
  link_rx_cpp xi2;
  link_channel_cpp xi1;
// internal nodes
  double tx_data_out;
  double rx_data_out;
  double del;
  double rx_clk;
  double ber;
  int counter;
  double net28;
  double tx_out;
  double tx_out_delay;
  double ch_out;
  double net31;
  double net33;
private:
};

/////////////////////////////////////////////////////

