// Testbench for VppSim simulation of module 'link_topV'
// Created on:  6/23/2008 13:16:29

`timescale 10ps/10ps

// set CppSim time step value  (from Ts:)
`define Ts 1.000e-11

// global variables (from global_param:)
`define ratio 10
`define symbol_freq 10000000000.0
`define trigger_freq 10000000000.0
`define eq_tap_length 5
`define num_cdr_phases 10
`define num_maj_votes 1024
`define delay 0
`define ts 1.0000000000e-11
`define pi 3.1415926536e+00

module link_topV_test();

  // timing signal for CppSim modules
  reg cppsim_timing_in;
  wire cppsim_timing_out;

  always
     begin
       #1
       cppsim_timing_in = 1'b0;
       #1
       cppsim_timing_in = 1'b1;
     end


  // top module instantiation
  link_topV xi_top(cppsim_timing_in, cppsim_timing_out);

  // Simulation commands
  initial
    begin
       // set CppSim time step value  (from Ts:)
       $set_Ts_value(`Ts);

       // number of simulation time steps (from num_sim_steps:)
       #500000
       $finish;
     end

  // real variables to support Probe statements for Matlab interface
  real xi_top_tx_out_file1;
  initial
    assign xi_top_tx_out_file1 = xi_top.tx_out;
  real xi_top_tx_out_delay_file1;
  initial
    assign xi_top_tx_out_delay_file1 = xi_top.tx_out_delay;
  real xi_top_ch_out_file1;
  initial
    assign xi_top_ch_out_file1 = xi_top.ch_out;
  real xi_top_rx_data_out_file1;
  initial
    assign xi_top_rx_data_out_file1 = xi_top.rx_data_out;

  // Probe statements for Matlab interface (from probe:)
  always@cppsim_timing_out
    begin
       $probe_node("test.tr0","tx_out",xi_top_tx_out_file1);
       $probe_node("test.tr0","tx_out_delay",xi_top_tx_out_delay_file1);
       $probe_node("test.tr0","ch_out",xi_top_ch_out_file1);
       $probe_node("test.tr0","rx_data_out",xi_top_rx_data_out_file1);
       $probe_node("test.tr0","tx_data_out",xi_top.tx_data_out);
    end


endmodule
