#include "/mit/6.22s/tools/vppsim/VppSimShared/CommonCode/cppsim_classes.h"
#include "/mit/6.22s/tools/vppsim/VppSimShared/CommonCode/my_classes_and_functions.h"
#include "vxl_veriuser.h"
#include "veriuser.h"

// global variables
double Ts=1.00000000e-11;
int stop_current_alter_run = 0;

struct VECTOR_LINKED_LIST
   {
   Vector *vec;
   IntVector *ivec;
   struct VECTOR_LINKED_LIST *next;
};
typedef struct VECTOR_LINKED_LIST VECTOR_LINKED_LIST;

struct PROBE_LINKED_LIST
   {
   Probe *probe;
   char name[MAX_CHAR_LENGTH];
   int cur_step, first_step, last_step, enable, cur_step_flag;
   double prev_trig_sig, trigger_val;
   struct PROBE_LINKED_LIST *next;
};
typedef struct PROBE_LINKED_LIST PROBE_LINKED_LIST;

struct PROBE_ELEM
   {
   PROBE_LINKED_LIST *Probe;
   Vector *vec;
   IntVector *ivec;
   int min_elem, max_elem, is_vector_flag;
   double prev_val;
   char node_name[MAX_NODE_NAME_LENGTH];
};
typedef struct PROBE_ELEM PROBE_ELEM;

PROBE_LINKED_LIST *global_probe_linked_list = NULL;
VECTOR_LINKED_LIST *global_vector_linked_list = NULL;

void delete_probe_from_global_list(char *output_filename);
PROBE_LINKED_LIST *retrieve_probe_from_global_list(char *output_filename);
PROBE_LINKED_LIST *init_probe_linked_list_entry(char *output_filename);
PROBE_ELEM *init_probe_elem(char *node_name,PROBE_LINKED_LIST *probe);
int determine_max_min_elem(char *in, char *control_string);

vector_struct *retrieve_vector_from_global_list(int vec_num);
int_vector_struct *int_retrieve_vector_from_global_list(int vec_num);
int add_to_global_vector_list(Vector *in);
int add_to_global_vector_list(IntVector *in);
VECTOR_LINKED_LIST *init_vector_linked_list_entry(Vector *in);
VECTOR_LINKED_LIST *init_vector_linked_list_entry(IntVector *in);

extern "C" int probe_start_sample_cpp_calltf();
extern "C" int probe_start_sample_cpp_misctf(int data, int reason);

extern "C" int probe_end_sample_cpp_calltf();
extern "C" int probe_end_sample_cpp_misctf(int data, int reason);

extern "C" int probe_start_time_cpp_calltf();
extern "C" int probe_start_time_cpp_misctf(int data, int reason);

extern "C" int probe_end_time_cpp_calltf();
extern "C" int probe_end_time_cpp_misctf(int data, int reason);

extern "C" int probe_enable_cpp_calltf();
extern "C" int probe_enable_cpp_misctf(int data, int reason);

extern "C" int probe_trigger_cpp_calltf();
extern "C" int probe_trigger_cpp_misctf(int data, int reason);

extern "C" int probe_node_cpp_calltf();
extern "C" int probe_node_cpp_misctf(int data, int reason);

extern "C" int set_Ts_value_cpp_calltf();
extern "C" int set_Ts_value_cpp_misctf(int data, int reason);

extern "C" int get_vector_elem_cpp_calltf();
extern "C" int get_vector_elem_cpp_misctf(int data, int reason);

extern "C" int get_intvector_elem_cpp_calltf();
extern "C" int get_intvector_elem_cpp_misctf(int data, int reason);

class signal_source_cpp
{
public:
  signal_source_cpp(double freq,int stype);
  ~signal_source_cpp();
  void inp(double phase_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double clk;
  double out;
// inputs
  double phase;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
  double freq_arg_in;
  int stype_arg_in;
// classes
  SigGen siggen1;
  List list1;
// functions
private:
};

extern "C" int signal_source_cpp_calltf();
extern "C" int signal_source_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class tx_eqV_cpp
{
public:
  tx_eqV_cpp();
  ~tx_eqV_cpp();
  void inp(double clk_in_arg_in,double data_in_arg_in);
  void init(int eq_settings_vec);
  void init_output_vectors();
// outputs
  double tx_eq_out;
// inputs
  Vector eq_settings_vec;
  vector_struct *eq_settings_vec_struct_hold;
  double clk_in;
  double data_in;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
// classes
  Filter filt_eq;
  EdgeDetect neg_edge;
  List eq_tap_list;
// functions
private:
};

extern "C" int tx_eqV_cpp_calltf();
extern "C" int tx_eqV_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class eq_setting_from_file_cpp
{
public:
  eq_setting_from_file_cpp(int num_tap);
  ~eq_setting_from_file_cpp();
  void inp();
  void init();
  void init_output_vectors();
// outputs
  Vector vec_out;
// inputs
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
  int num_tap_arg_in;
// classes
  List list1;
// functions
private:
};

extern "C" int eq_setting_from_file_cpp_calltf();
extern "C" int eq_setting_from_file_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class constant_cpp
{
public:
  constant_cpp(double consval);
  ~constant_cpp();
  void inp();
  void init();
  void init_output_vectors();
// outputs
  double out;
// inputs
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
  double consval_arg_in;
// classes
// functions
private:
};

extern "C" int constant_cpp_calltf();
extern "C" int constant_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class link_channel_cpp
{
public:
  link_channel_cpp();
  ~link_channel_cpp();
  void inp(double channel_in_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double channel_out;
// inputs
  double channel_in;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
// classes
  List channel_taps;
  Filter filt_ch;
// functions
private:
};

extern "C" int link_channel_cpp_calltf();
extern "C" int link_channel_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class divider_ideal_cpp
{
public:
  divider_ideal_cpp();
  ~divider_ideal_cpp();
  void inp(double div_val_arg_in,double in_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double out;
// inputs
  double div_val;
  double in;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
// classes
  Divider div1;
// functions
private:
};

extern "C" int divider_ideal_cpp_calltf();
extern "C" int divider_ideal_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class phase_interpolator_cpp
{
public:
  phase_interpolator_cpp(int num_phases,double clk_freq);
  ~phase_interpolator_cpp();
  void inp(double clk_arg_in,int phase_select_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double clk_edge;
  double clk_data;
  double clk_adapt;
// inputs
  double clk;
  int phase_select;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
  int num_phases_arg_in;
  double clk_freq_arg_in;
// classes
  Delay delay_data;
  Delay delay_edge;
  Delay delay_adapt;
// functions
private:
};

extern "C" int phase_interpolator_cpp_calltf();
extern "C" int phase_interpolator_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class cdr_counter_cpp
{
public:
  cdr_counter_cpp(int range);
  ~cdr_counter_cpp();
  void inp(double clk_arg_in,double enable_b_arg_in,double inc_dec_arg_in);
  void init();
  void init_output_vectors();
// outputs
  int count;
// inputs
  double clk;
  double enable_b;
  double inc_dec;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
  int range_arg_in;
// classes
  EdgeDetect pos_edge;
  Delay delay_clk;
  Probe probe1;
// functions
private:
};

extern "C" int cdr_counter_cpp_calltf();
extern "C" int cdr_counter_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class cdr_maj_vote_cpp
{
public:
  cdr_maj_vote_cpp(int num_maj_votes);
  ~cdr_maj_vote_cpp();
  void inp(double div_clk_arg_in,double clk_arg_in,double valid_transition_arg_in,double early_late_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double hold;
  double up_down;
// inputs
  double div_clk;
  double clk;
  double valid_transition;
  double early_late;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
  int num_maj_votes_arg_in;
// classes
  Filter maj_filter;
  EdgeDetect pos_edge1;
  EdgeDetect pos_edge2;
  List filter_tap_list;
// functions
private:
};

extern "C" int cdr_maj_vote_cpp_calltf();
extern "C" int cdr_maj_vote_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class xor2_cpp
{
public:
  xor2_cpp();
  ~xor2_cpp();
  void inp(double a_arg_in,double b_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double y;
// inputs
  double a;
  double b;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
// classes
  Xor xor1;
// functions
private:
};

extern "C" int xor2_cpp_calltf();
extern "C" int xor2_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class inv_cpp
{
public:
  inv_cpp();
  ~inv_cpp();
  void inp(double a_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double y;
// inputs
  double a;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
// classes
// functions
private:
};

extern "C" int inv_cpp_calltf();
extern "C" int inv_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class latch1_cpp
{
public:
  latch1_cpp();
  ~latch1_cpp();
  void inp(double latch_arg_in,double d_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double q;
// inputs
  double latch;
  double d;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
// classes
  Latch lat1;
// functions
private:
};

extern "C" int latch1_cpp_calltf();
extern "C" int latch1_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class limitamp_cpp
{
public:
  limitamp_cpp();
  ~limitamp_cpp();
  void inp(double in_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
  double prev_in;
  int state;
// parameters
// classes
// functions
private:
};

extern "C" int limitamp_cpp_calltf();
extern "C" int limitamp_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class sub2_cpp
{
public:
  sub2_cpp();
  ~sub2_cpp();
  void inp(double in2_arg_in,double in1_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in2;
  double in1;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
// classes
// functions
private:
};

extern "C" int sub2_cpp_calltf();
extern "C" int sub2_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class sampler_cpp
{
public:
  sampler_cpp();
  ~sampler_cpp();
  void inp(double clk_arg_in,double in_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double out;
// inputs
  double clk;
  double in;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
  double prev_in;
// parameters
// classes
  EdgeDetect rising_edge;
// functions
private:
};

extern "C" int sampler_cpp_calltf();
extern "C" int sampler_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

class delay_sample_scalar_cpp
{
public:
  delay_sample_scalar_cpp(int delay);
  ~delay_sample_scalar_cpp();
  void inp(double in_arg_in);
  void init();
  void init_output_vectors();
// outputs
  double out;
// inputs
  double in;
// module initialization flag (used only for PLI modules)
  int vpp_init_module_flag;
// static variables
// parameters
  int delay_arg_in;
// classes
  Filter filt;
// functions
private:
};

extern "C" int delay_sample_scalar_cpp_calltf();
extern "C" int delay_sample_scalar_cpp_misctf(int data, int reason);

/////////////////////////////////////////////////////

