function w=zfe(imp,Tsym,Ts,L,num_pre)
%%% Computes linear zero-forcing equalizer coefficients
%%% with peak power constraint scaled to one
%%% inputs
%   imp - channel impulse response
%   Ts  - impulse response time quantization
%   Tsym - symbol duration
%   L   - equalizer length
%   num_pre - number of precursors in the equalizer
%%% output
%   w   - equalizer coefficients

% clear all; close all;clc; 
% Tsym=100e-12; Ts=Tsym/10; L=30; num_pre=10;
% imp=load('link_top\link_channel.dat','ASCII');

pulse_response_data=[zeros(1,floor(Tsym/Ts)) ones(1,floor(Tsym/Ts)) zeros(1,floor(Tsym/Ts))];
pulse_response = conv(imp,pulse_response_data);

[foo,index_max]=max(pulse_response);
symbol_index = round( (index_max-floor(index_max*Ts/Tsym)*Tsym/Ts):Tsym/Ts:length(pulse_response));
p=pulse_response(symbol_index);

[foo,main_index]=max(p);
main_eq_index=main_index+num_pre-1;
delta_vec=zeros(1,L+length(p)-1);
delta_vec(main_eq_index)=1;
for n=1:L,
    P(n,:)=[zeros(1,n-1) p zeros(1,L-n)];
end
w=(inv(P*P')*P*delta_vec')';
w=w/sum(abs(w));

figure(12)
stem(w*P);
title('equalized symbol spaced pulse response');

