function [ysigi_rot,ysigq_rot,theta] = gmsk(i)

x = loadsig('test_eye.tr0');
ysigi = evalsig(x,'ifilt');
ysigq = evalsig(x,'qfilt');

ysigi = ysigi - mean(ysigi);
ysigq = ysigq - mean(ysigq);


theta_vec = (0:0.1:1.0)*pi/2;

min_i = find_best_theta(theta_vec,ysigi,ysigq);
if min_i < 2
   theta_vec = theta_vec - pi/4; 
   min_i = find_best_theta(theta_vec,ysigi,ysigq);
end
if min_i > 9
   theta_vec = theta_vec + pi/4; 
   min_i = find_best_theta(theta_vec,ysigi,ysigq);
end

theta_min = theta_vec(min_i-1);
theta_max = theta_vec(min_i+1);
delta_theta = (theta_max - theta_min)/10;

theta_vec = theta_min:delta_theta:theta_max;
min_i = find_best_theta(theta_vec,ysigi,ysigq);

theta = theta_vec(min_i);
ysigi_rot = ysigi*cos(theta) - ysigq*sin(theta);
ysigq_rot = ysigi*sin(theta) + ysigq*cos(theta);


function [min_i] = find_best_theta(theta_vec,ysigi,ysigq) 

min_i = -1;
max_count = 0;
for i = 1:length(theta_vec)
   theta = theta_vec(i);
   ysigi_rot = ysigi*cos(theta) - ysigq*sin(theta);
   ysigq_rot = ysigi*sin(theta) + ysigq*cos(theta);

   cur_count = 0;
   min_count = 10e6;
   for j = 2:length(ysigi)
     if sign(ysigi_rot(j)) ~= sign(ysigi_rot(j-1))
        if (cur_count < min_count) 
           min_count = cur_count;
        end
        cur_count = 0;     
     end
     if sign(ysigq_rot(j)) ~= sign(ysigq_rot(j-1))
        if (cur_count < min_count) 
           min_count = cur_count;
        end
        cur_count = 0;     
     end
     cur_count = cur_count + 1;
   end
     if min_count > max_count
        max_count = min_count;
        min_i = i;
     end
end

