# Copyright (c) 2004-2011 Synopsys, Inc. This Galaxy Custom Designer software
# and the associated documentation are confidential and proprietary to
# Synopsys, Inc. Your use or disclosure of this Galaxy Custom Designer software
# is subject to the terms and conditions of a written license agreement between
# you, or your company, and Synopsys, Inc.

# Project:      schematic_editor
# File:         schematic_menus.tcl
# Description:  Schematic Editor menu definitions


namespace eval ::startup {
    set wt [gi::getWindowTypes seSchematic]

    global CUR_SIM_FILE CUR_CPPSIM_SIM_FILE HSPICE_SIM_MENU CPPSIM_SIM_MENU

    set CUR_SIM_FILE "test.hspc"
    set CUR_CPPSIM_SIM_FILE "test.par"

    # HSPC menu actions
    gi::createAction "HspcChooseSimFile" \
        -title "Choose Alternative Sim File (test.hspc is default)" \
	-command {hspc_choose_sim_file [gi::getActiveWindow]}

    gi::createAction "HspcEditSimFile" \
        -title "Edit Sim File" \
	-command {hspc_edit_sim_file [gi::getActiveWindow]}

    gi::createAction "HspcNetlist" \
        -title "Netlist Only" \
        -command {hspc_netlist_only [gi::getActiveWindow] "full"}

    gi::createAction "HspcNetlistandRun" \
        -title "Run Netlist/HSPC/Hspice" \
        -command {hspc_netlist_and_run [gi::getActiveWindow]}

    gi::createAction "HspcViewLogFile" \
        -title "View Log File" \
        -command {hspc_view_log_file [gi::getActiveWindow]}

    gi::createAction "HspcStartCustomWaveViewTR" \
        -title "Start Custom WaveView (Transient)" \
        -command {hspc_start_custom_waveview_tr [gi::getActiveWindow]}

    gi::createAction "HspcStartCustomWaveViewAC" \
        -title "Start Custom WaveView (AC)" \
        -command {hspc_start_custom_waveview_ac [gi::getActiveWindow]}

    gi::createAction "HspcStartCustomWaveViewDC" \
        -title "Start Custom WaveView (DC)" \
        -command {hspc_start_custom_waveview_dc [gi::getActiveWindow]}

    gi::createAction "HspcKillRun" \
        -title "Kill Hspice Run" \
        -command {hspc_kill_run [gi::getActiveWindow]}

    # CppSim menu actions

    gi::createAction "CppSimChooseSimFile" \
        -title "Choose Alternative Sim File (test.par is default)" \
	-command {cppsim_choose_sim_file [gi::getActiveWindow]}

    gi::createAction "CppSimEditSimFile" \
        -title "Edit Sim File" \
	-command {cppsim_edit_sim_file [gi::getActiveWindow]}

#    gi::createAction "CppSimNetlist" \
#        -title "CppSim Netlist Only" \
#        -command {cppsim_netlist_only_hspice_based [gi::getActiveWindow] "full"}

    gi::createAction "CppSimNetlist" \
        -title "CppSim Netlist Only" \
        -command {cppsim_netlist_only [gi::getActiveWindow] "full"}

    gi::createAction "CppSimNetlistandRun" \
        -title "Run Netlist/CppSim" \
        -command {cppsim_netlist_and_run [gi::getActiveWindow] 0}

    gi::createAction "VppSimNetlistandRun" \
        -title "Run Netlist/VppSim" \
        -command {cppsim_netlist_and_run [gi::getActiveWindow] 1}

    gi::createAction "CppSimStartCustomWaveView" \
        -title "Start Custom WaveView (CppSim)" \
        -command {cppsim_start_custom_waveview [gi::getActiveWindow]}

    gi::createAction "CppSimKillRun" \
        -title "Kill CppSim Run" \
        -command {cppsim_kill_run [gi::getActiveWindow]}

    # LocalDoc menu actions

    gi::createAction "LocalDocOpenCDPlatformManual" \
        -title "Custom Designer Platform User Guide" \
        -command {local_doc_open_custom_designer_platform_user_guide [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenCDSchematicManual" \
        -title "Custom Designer Schematic User Guide" \
        -command {local_doc_open_custom_designer_schematic_user_guide [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenCDSchematicDrivenLayoutManual" \
        -title "Custom Designer Schematic Driven Layout User Guide" \
        -command {local_doc_open_custom_designer_schematic_driven_layout_user_guide [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenCDLayoutManual" \
        -title "Custom Designer Layout User Guide" \
        -command {local_doc_open_custom_designer_layout_user_guide [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenHspiceDocHTML" \
        -title "Hspice Documentation (HTML)" \
        -command {local_doc_open_hspice_documentation_html [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenHspiceDocPDF" \
        -title "Hspice Documentation (PDF)" \
        -command {local_doc_open_hspice_documentation_pdf [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenHspiceModelNamesPDF" \
        -title "Hspice MOSFET Parameter Names for .probe" \
        -command {local_doc_open_hspice_mosfet_parameter_names_pdf [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenHSPCDoc" \
        -title "HSPC Manual" \
        -command {local_doc_open_hspc_manual [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenHspiceToolboxMatlabDoc" \
        -title "Hspice Toolbox For Matlab Documentation" \
        -command {local_doc_open_hspice_toolbox_for_matlab_manual [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenSAEUserManual" \
        -title "SAE User Manual" \
        -command {local_doc_open_sae_user_manual [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenTclRefManual" \
        -title "TCL Reference Manual" \
        -command {local_doc_open_tcl_ref_manual [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenCWaveManual" \
        -title "Custom WaveView User Manual" \
        -command {local_doc_open_custom_waveview_manual [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenCWaveQuickRef" \
        -title "Custom WaveView Quick Reference" \
        -command {local_doc_open_custom_waveview_quick_ref [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenUsagePdkTsmc18" \
        -title "TSMC 180nm PDK Usage Guide" \
        -command {local_doc_open_tsmc_180nm_pdk_usage_guide [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenNoiseTsmc18" \
        -title "TSMC 180nm PDK 1/f Noise Data" \
        -command {local_doc_open_tsmc_180nm_noise_data [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenDesignRulesTsmc18" \
        -title "Mixed-Signal TSMC18 Design Rules" \
        -command {local_doc_open_tsmc18_design_rules [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenGenDesignRulesTsmc18" \
        -title "General TSMC18 Design Rules" \
        -command {local_doc_open_gen_tsmc18_design_rules [gi::getActiveWindow]}

    gi::createAction "LocalDocOpenDeepNwellInfoTsmc18" \
        -title "Information on TSMC18 Deep Nwell Devices" \
        -command {local_doc_open_tsmc18_deep_nwell [gi::getActiveWindow]}


    gi::createBinding -event "Alt-n" -windowType seSchematic -action CppSimNetlist
    gi::createBinding -event "Alt-h" -windowType seSchematic -action HspcNetlistandRun
    gi::createBinding -event "Alt-c" -windowType seSchematic -action CppSimNetlistandRun
    gi::createBinding -event "Alt-v" -windowType seSchematic -action VppSimNetlistandRun
    gi::createBinding -event "Alt-e" -windowType seSchematic -action HspcEditSimFile
    gi::createBinding -event "Alt-p" -windowType seSchematic -action CppSimEditSimFile
    gi::createBinding -event "Alt-l" -windowType seSchematic -action HspcViewLogFile

    # HSPC menu creation
    set m [gi::createMenu seHSPCSimMenu -title "HSPC" -dynamic true]

    set HSPICE_SIM_MENU $m
    # set m [gi::getMenus Opt* -from [gi::getWindowTypes seSchematic]]
    #    Note:  use giSeparator below if demarcation lines are desired

    gi::addActions {
        { HspcChooseSimFile     "Choose Alternative Sim File (test.hspc is default)" }
        { HspcEditSimFile     "Edit Sim File" }
        giSeparator
        { HspcNetlist          "Netlist Only" }
        { HspcNetlistandRun    "Run Hspice (with Netlisting and HSPC)" }
        { HspcViewLogFile    "View Log File" }
        giSeparator
        { HspcStartCustomWaveViewTR    "Start Custom WaveView (Transient)" }
        { HspcStartCustomWaveViewAC    "Start Custom WaveView (AC)" }
        { HspcStartCustomWaveViewDC    "Start Custom WaveView (DC)" }
        giSeparator
        { HspcKillRun    "Kill Hspice Run" }
    } -to $m
    gi::addMenu $m -to $wt

    # CppSim menu creation
    set m [gi::createMenu seCppSimMenu -title "CppSim" -dynamic true]

    set CPPSIM_SIM_MENU $m
    # set m [gi::getMenus Opt* -from [gi::getWindowTypes seSchematic]]
    #    Note:  use giSeparator below if demarcation lines are desired

    gi::addActions {
        { CppSimChooseSimFile     "Choose Alternative Sim File (test.par is default)" }
        { CppSimEditSimFile     "Edit Sim File" }
        giSeparator
        { CppSimNetlist          "Netlist Only" }
        { CppSimNetlistandRun    "Run CppSim (with Netlisting)" }
        { VppSimNetlistandRun    "Run VppSim (with Netlisting)" }
        giSeparator
        { CppSimStartCustomWaveView    "Start Custom WaveView (CppSim/VppSim)" }
        giSeparator
        { CppSimKillRun    "Kill CppSim/VppSim Run" }
    } -to $m
    gi::addMenu $m -to $wt

    # LocalDoc menu creation
    set m [gi::createMenu seLocalDocMenu -title "LocalDoc" -dynamic true]

    # set m [gi::getMenus Opt* -from [gi::getWindowTypes seSchematic]]
    #    Note:  use giSeparator below if demarcation lines are desired

    gi::addActions {
        { LocalDocOpenCDPlatformManual  "Custom Designer Platform User Guide" }
        { LocalDocOpenCDSchematicManual  "Custom Designer Schematic User Guide" }
        { LocalDocOpenCDSchematicDrivenLayoutManual  "Custom Designer Schematic Driven Layout User Guide" }
        { LocalDocOpenCDLayoutManual  "Custom Designer Layout User Guide" }
        { LocalDocOpenSAEUserManual  "SAE User Manual" }
        { LocalDocOpenTclRefManual  "TCL Reference Manual" }
        giSeparator
        { LocalDocOpenCWaveManual  "Custom WaveView User Manual" }
        { LocalDocOpenCWaveQuickRef  "Custom WaveView Quick Reference" }
        giSeparator
        { LocalDocOpenHspiceDocHTML  "Hspice Documentation (HTML)" }
        { LocalDocOpenHspiceDocPDF  "Hspice Documentation (PDF)" }
        { LocalDocOpenHspiceModelNamesPDF  "Hspice MOSFET Parameter Names for .probe" }
        giSeparator
        { LocalDocOpenHSPCDoc  "HSPC Documentation" }
        { LocalDocOpenHspiceToolboxMatlabDoc  "Hspice Toolbox For Matlab Documentation" }
        giSeparator
        { LocalDocOpenUsagePdkTsmc18  "TSMC 180nm PDK Usage Guide" }
        { LocalDocOpenNoiseTsmc18  "TSMC 180nm 1/f Noise Data" }
        { LocalDocOpenGenDesignRulesTsmc18 "General TSMC18 Design Rules" }
        { LocalDocOpenDesignRulesTsmc18 "Mixed-Signal TSMC18 Design Rules" }
	{ LocalDocOpenDeepNwellInfoTsmc18 "Information on TSMC18 Deep Nwell Devices" }

    } -to $m
    gi::addMenu $m -to $wt

}

