%
%   Written by Michael Perrott for viewing CppSim/VppSim output
%   Distribution:  http://www.cppsim.com
%
%   This code is used as part of the CppSimView program
%   (cppsimview.m)
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function [] = add_right_axis(cur_ax,y_offset,ylabel)

%%% determine ylimits to coincide with current axis after it
%%%    has later been scaled by 10%
ylim = get(cur_ax,'YLim');
delta_y = (ylim(2)-ylim(1))*0.1;
ylim_new = [ylim(1)-delta_y ylim(2)+delta_y];
set(cur_ax,'YLim',ylim_new);

%%% shorten width of current axes
cur_pos = get(cur_ax,'Position');
cur_pos(3) = cur_pos(3)*.93;
set(cur_ax,'Position',cur_pos);

%%% create right hand axes
right_ax = axes;
set(right_ax,'YLim',ylim_new);
new_pos = cur_pos;
new_pos(1) = cur_pos(1)+cur_pos(3)+0.02;
new_pos(3) = 0.001;
set(right_ax,'Position',new_pos);
set(right_ax,'YAxisLocation','right');

%%% create y tick marks
ytick = get(cur_ax,'YTickLabel');
ytick = cellstr(ytick);
top_ytick = str2num(char(ytick(length(ytick))));
bot_ytick = str2num(char(ytick(1)));
new_tick_inc = (top_ytick-bot_ytick)/(length(ytick)-1);
new_tick = (0:(length(ytick)-1))*new_tick_inc + y_offset + bot_ytick;
set(right_ax,'YTickLabel',new_tick);

%%% set ylimits of cur axes back to unscaled value
set(cur_ax,'YLim',ylim);


%%% get rid of x tick marks
set(right_ax,'XTickLabel',[]);
set(right_ax,'XTick',[]);

%%% set color of right axes to red
%%set(right_ax,'YColor',[1 0 0]);

%%% ylabel the right axes
set(get(right_ax,'YLabel'),'String',ylabel);

