%
%   Written by Michael Perrott for viewing CppSim/VppSim output
%   Distribution:  http://www.cppsim.com
%
%   This code is used as part of the CppSimView program
%   (cppsimview.m)
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function date_metric = convert_date_to_metric(date)

[day,r] = strtok(date,'-');
[month,r] = strtok(r,'-');
[year,r] = strtok(r,'- ');
[hour,r] = strtok(r,': ');
[min,r] = strtok(r,': ');
[sec,r] = strtok(r,': ');


switch lower(month)
   case 'jan'
      month_num = '1';
   case 'feb'
      month_num = '2';
   case 'mar'
      month_num = '3';
   case 'apr'
      month_num = '4';
   case 'may'
      month_num = '5';
   case 'jun'
      month_num = '6';
   case 'jul'
      month_num = '7';
   case 'aug'
      month_num = '8';
   case 'sep'
      month_num = '9';
   case 'oct'
      month_num = '10';
   case 'nov'
      month_num = '11';
   case 'dec'
      month_num = '12';
   otherwise
      month_num = '0';
end

date_metric = strcat(year,month_num,day,hour,min,sec);
date_metric = str2num(date_metric);
