%
%   cppsimview: a waveform viewer written in MATLAB code
%   by Michael Perrott for viewing CppSim/Cppsim output
%   Distribution:  http://www.cppsim.com
%
%   To use this code in Matlab, simply run Matlab (version 7
%   or greater) and then type:
%   cd location_of_this_directory
%   mex loadsig_cppsim.c
%   mex min_max_decimate.c
%   addpath('location_of_this_program')
%   cppsimview
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%


function varargout = cppsimview(varargin)
% CPPSIMVIEW M-file for cppsimview.fig
%      CPPSIMVIEW, by itself, creates a new CPPSIMVIEW or raises the existing
%      singleton*.
%
%      H = CPPSIMVIEW returns the handle to a new CPPSIMVIEW or the handle to
%      the existing singleton*.
%
%      CPPSIMVIEW('Property','Value',...) creates a new CPPSIMVIEW using the
%      given property value pairs. Unrecognized properties are passed via
%      varargin to CppsimView_OpeningFcn.  This calling syntax produces a
%      warning when there is an existing singleton*.
%
%      CPPSIMVIEW('CALLBACK') and CPPSIMVIEW('CALLBACK',hObject,...) call the
%      local function named CALLBACK in CPPSIMVIEW.M with the given input
%      arguments.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help CppsimView

% Last Modified by GUIDE v2.5 28-Jul-2005 17:31:24

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @CppsimView_OpeningFcn, ...
                   'gui_OutputFcn',  @CppsimView_OutputFcn, ...
                   'gui_LayoutFcn',  [], ...
                   'gui_Callback',   []);
if nargin & isstr(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before CppsimView is made visible.
function CppsimView_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   unrecognized PropertyName/PropertyValue pairs from the
%            command line (see VARARGIN)

% Choose default command line output for CppsimView

rehash toolboxcache;

	fig = openfig(mfilename,'reuse');
        handles.main_handle = fig;
        set(fig,'Name','CppsimView');
        set(fig,'CloseRequestFcn','close_req_function');

cppsim_home_var = getenv('CPPSIMHOME');

if length(cppsim_home_var) == 0
    mssg = sprintf('Error:  UNIX environment variable CPPSIMHOME is undefined!\n  -> you must fix this before CppsimView will run\n');
    uiwait(msgbox(mssg,'Error trying to locate Cppsim home directory','modal'));
    close_req_function;
end

if isdir(cppsim_home_var) == 0
    mssg = sprintf('Error:  UNIX environment variable CPPSIMHOME points to an invalid directory %s\n  -> you must fix this before CppsimView will run',cppsim_home_dir);
    uiwait(msgbox(mssg,'Error trying to locate Cppsim home directory','modal'));
    close_req_function;
end

handles.home=cppsim_home_var;

cppsimshared_home_var = getenv('CPPSIMSHAREDHOME');

if length(cppsimshared_home_var) == 0
    mssg = sprintf('Error:  UNIX environment variable CPPSIMSHAREDHOME is undefined!\n  -> you must fix this before CppsimView will run\n');
    uiwait(msgbox(mssg,'Error trying to locate CppsimShared home directory','modal'));
    close_req_function;
end

if isdir(cppsimshared_home_var) == 0
    mssg = sprintf('Error:  UNIX environment variable CPPSIMSHAREDHOME points to an invalid directory %s\n  -> you must fix this before CppsimView will run',cppsim_home_dir);
    uiwait(msgbox(mssg,'Error trying to locate CppsimShared home directory','modal'));
    close_req_function;
end

handles.root_dir = cppsimshared_home_var;
%handles.root_dir = char(get_root_dir_cppsim(netlist));

%netlist = sprintf('%s/Netlist/netlist.cppsim',handles.home);



%%% Setup Plot Figure

%        fHandle = figure('HandleVisibility','on','IntegerHandle','off',...
%			 'Visible','off');
%        aHandle = axes('Parent',fHandle,'LineWidth',1.5); 
        plot_fig_filename = sprintf('%s/MatlabGui/CppsimView/cppsimview_plot.fig',handles.root_dir);
        plot_fig = openfig(plot_fig_filename,'new');
        plot_fig_handles = guihandles(plot_fig);
        fHandle = plot_fig_handles.figure1;
        aHandle = plot_fig_handles.axes1;

        set(fHandle,'Visible','on');
        set(fHandle,'HandleVisibility','on');
        set(fHandle,'IntegerHandle','off');
        set(fHandle,'Name','Plot for CppsimView');
        set(fHandle,'NumberTitle','off');
        set(aHandle,'LineWidth',1.5);
        set(aHandle,'Color',[0.0 0.0 0.0]);
        set(aHandle,'XColor',[1.0 1.0 1.0]);
        set(aHandle,'YColor',[1.0 1.0 1.0]);
        set(fHandle,'Color',[0.0 0.0 0.0]);
        color_order = [1 1 0; 1 0 1; 0 1 1; 1 0 0; 0 1 0; 0 0 1; .75 .75 .75];
        set(fHandle,'DefaultAxesColorOrder',color_order);
        set(aHandle,'ColorOrder',color_order);

        guidata(plot_fig,plot_fig_handles);
        handles.fighandle = plot_fig;
        global plot_axes_handle;
        plot_axes_handle = aHandle;        
        handles.plot_handle = fHandle;        
        global background_color;
        background_color = 'white';

        global xzoom_flag;
        xzoom_flag = 0;
        global plot_linewidth;
        plot_linewidth = 1.0;

        global change_function_flag
        change_function_flag = 0;

handles.output = hObject;

handles.LastPlotFile = '';


set(handles.radio_test,'String','No Sim File');
set(handles.radio_test,'ForegroundColor','red');
set(handles.radio_test,'Value',0);
set(handles.listbox_shared,'String',[]);
set(handles.listbox_shared,'Value',1);

set(handles.pushbutton_edit_test_par,'String','Edit Sim File');

set(handles.edit_plot_entry,'Enable','off'); 
set(handles.edit_plot_entry,'BackgroundColor',[0.831,0.816,0.784]);
set(handles.edit_plot_entry,'String','');

handles.copy_sim_file_name = [];
handles.paste_sim_file_name = [];
handles.copy_sim_file_name_candidate = [];
handles.cur_message = ' ';
global message_lock_flag;
message_lock_flag = 0;
handles.cur_dir = ' ';
handles.new_sim_file_name = [];
handles.plot_history_buff = cell(430,3); 
handles.plot_history_index = 1;
handles.plot_history_scroll_index = 0;
handles.plot_history_buff{1,1}= ' '; 
handles.plot_history_buff{1,2}= ' '; 
handles.plot_history_buff{1,3}= ' '; 


set(handles.radio_test_tr0,'String','No Output File');
set(handles.radio_test_tr0,'ForegroundColor','red');

set(handles.radio_plot_function,'String','plotsig(...)');

set(handles.radio_nodes,'String','No Nodes');
set(handles.radio_nodes,'ForegroundColor','red');
handles.reload_nodes_flag = 1;


global x_sig
x_sig = [];
handles.shared_listbox_flag = 0;
handles.listbox_test_index = 1;
handles.listbox_test_tr0_index = 1;
handles.listbox_nodes_index = 1;
handles.old_num_test_files = 0;
handles.old_num_test_tr0_files = 0;
handles.old_num_nodes = 0;
handles.listbox_plot_function_index = 1;
handles.plot_functions = 'plotsig(x,''nodes'')';
handles.plot_functions = strvcat(handles.plot_functions,'plot_xy(x,''x_sig'',''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_fft(x,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_mag(x,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_db(x,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_db_mag(x,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_logx(x,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_logx_mag(x,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_db_logx(x,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_db_logx_mag(x,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'eyesig(x,period,start_time,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'eyesig_gmsk(x,period,start_time,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'scatter_eye_gmsk(x,symbol_rate,start_off,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_pll_phasenoise(x,f_low,f_high,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_psd(x,''nodes'',''logxy'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_psd_sqrt(x,''nodes'',''logxy'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_psd_db(x,''nodes'',''logx'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_pll_mod_spectrum(x,f_span,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_pll_jitter(x,''ref_timing_node'',start_edge,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_pll_jitter_vs_time(x,''ref_timing_node'',start_time,''nodes'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_title(''name'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_xlabel(''name'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_ylabel(''name'')');
handles.plot_functions = strvcat(handles.plot_functions,'plot_linewidth(value)');
handles.plot_nodes = [];

%%% include functions invoked through eval
impossible_flag = 0;
if impossible_flag == 1
    x = 1;
    plotsig_vpp(x,'nodes');
    plot_xy(x,'x_sig','nodes');
    plot_fft(x,'nodes');
    plot_fft_mag(x,'nodes');
    plot_fft_db(x,'nodes');
    plot_fft_db_mag(x,'nodes');
    plot_fft_logx(x,'nodes');
    plot_fft_logx_mag(x,'nodes');
    plot_fft_db_logx(x,'nodes');
    plot_fft_db_logx_mag(x,'nodes');
    eyesig_vpp(x,1,0,'nodes');
    eyesig_vpp_gmsk(x,1,0,'nodes');
    scatter_eye_gmsk(x,1,0,'nodes');
    plot_pll_phasenoise(x,10,100,'nodes');
    plot_psd(x,'nodes','logxy');
    plot_psd_sqrt(x,'nodes','logxy');
    plot_psd_db(x,'nodes','logx');
    plot_pll_mod_spectrum(x,10,'nodes');
    plot_pll_jitter(x,'ref',10,'nodes');
    plot_pll_jitter_vs_time(x,'ref',1e-12,'nodes');
    x = loadsig_cppsim('file');
    mult(1,2);
    div(1,2);
    xzoom;
    close_req_function;
end

colordef black;

% Update handles structure
guidata(hObject, handles);

pushbutton_sue2_synch_Callback(hObject, eventdata, handles);

% UIWAIT makes CppsimView wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = CppsimView_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;


% --- Executes during object creation, after setting all properties.
function listbox_shared_CreateFcn(hObject, eventdata, handles)
% hObject    handle to listbox_shared (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: listbox controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end


% --- Executes on selection change in listbox_shared.
function listbox_shared_Callback(hObject, eventdata, handles)
% hObject    handle to listbox_shared (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: contents = get(hObject,'String') returns listbox_shared contents as cell array
%        contents{get(hObject,'Value')} returns selected item from listbox_shared

global plot_axes_handle background_color plot_linewidth x_sig
global change_function_flag

index_selected = get(handles.listbox_shared,'Value');
name_list = get(handles.listbox_shared,'String');
name_cell = cellstr(name_list);
name = name_cell{index_selected};

if handles.shared_listbox_flag == 0 %% test.par files
    if handles.listbox_test_index ~= index_selected
        set(handles.radio_test_tr0,'String','No Output File');  
        set(handles.radio_test_tr0,'ForegroundColor','red');
        handles.listbox_test_tr0_index = 1;

        set(handles.radio_nodes,'String','No Nodes');    
        set(handles.radio_nodes,'ForegroundColor','red');  
        handles.reload_nodes_flag = 1;
        if strcmp(get(handles.pushbutton_plot,'String'),'Reset Node List') == 1
            handles.plot_nodes = [];
            set(handles.pushbutton_plot,'String','Plot');
        end
    end
    set(handles.radio_test,'String',name);
    handles.listbox_test_index = index_selected;
    guidata(hObject, handles);

  if strcmp(name,'New Sim File') == 1
         set(handles.radio_test,'ForegroundColor','red');
         set(handles.pushbutton_edit_test_par,'String','Create Sim File');  
         set(handles.edit_plot_entry,'Enable','on'); 
         set(handles.edit_plot_entry,'BackgroundColor',[1.0,1.0,1.0]);

         i = 1;
         while 1
            if i == 1
               new_sim_file_name = sprintf('test.par');
            else
               new_sim_file_name = sprintf('test%d.par',i);
            end
            i = i + 1;
            flag = 0;
            for j = 1:length(name_cell)
               if strcmp(name_cell{j},new_sim_file_name) == 1
                  flag = 1;
                  break;
               end
            end
            if flag == 1
               continue;
            else
               set(handles.edit_plot_entry,'String',new_sim_file_name);
               handles.new_sim_file_name = new_sim_file_name;
               break;
            end
     end
  else
      set(handles.radio_test,'ForegroundColor','black');
      set(handles.pushbutton_edit_test_par,'String','Edit Sim File');
      set(handles.edit_plot_entry,'Enable','off'); 
      set(handles.edit_plot_entry,'BackgroundColor',[0.831,0.816,0.784]);
      set(handles.edit_plot_entry,'String','');
      handles.copy_sim_file_name_candidate = sprintf('%s/%s',handles.cur_dir,name);
  end

  guidata(hObject, handles);
  if strcmp(get(handles.figure1,'SelectionType'),'open')
     if strcmp(name,'New Sim File') == 0
        pushbutton_edit_test_par_Callback(hObject, eventdata, handles);
     end
  end

elseif handles.shared_listbox_flag == 1 %% test.tr0 files
    if handles.listbox_test_tr0_index ~= index_selected
        set(handles.radio_nodes,'String','No Nodes');    
        set(handles.radio_nodes,'ForegroundColor','red');  
        handles.reload_nodes_flag = 1;
        if strcmp(get(handles.pushbutton_plot,'String'),'Reset Node List') == 1
            handles.plot_nodes = [];
            set(handles.pushbutton_plot,'String','Plot');
        end
    end

    set(handles.radio_test_tr0,'String',name);
    handles.listbox_test_tr0_index = index_selected;
    if strcmp(name,'No Output File') == 1
        set(handles.radio_test_tr0,'ForegroundColor','red');  
    else
        set(handles.radio_test_tr0,'ForegroundColor','black');
    end

elseif handles.shared_listbox_flag == 2 %% plot functions

    [base,r] = strtok(name,'(');
    switch base
        case 'plot_title'
        case 'plot_xlabel'
        case 'plot_ylabel'
        case 'plot_linewidth'
        otherwise
           base = sprintf('%s(...)',base);
           set(handles.radio_plot_function,'String',base);
           handles.listbox_plot_function_index = index_selected;
    end
    set(handles.edit_plot_entry,'String',name);

    if strcmp(get(handles.pushbutton_plot,'String'),'Reset Node List') == 1
        handles.plot_nodes = [];
        set(handles.pushbutton_plot,'String','Plot');
    end
    change_function_flag = 1;


elseif handles.shared_listbox_flag == 3 %% nodes
%    clipboard('copy',name);
    handles.listbox_nodes_index = index_selected;

    if strcmp(get(handles.figure1,'SelectionType'),'open')
       node_list = get(handles.listbox_shared,'String');
       node_cell_list = cellstr(node_list);
       cur_node = node_cell_list{index_selected};

       prev_plot_string = char(get(handles.edit_plot_entry,'String'));
       i = strfind(prev_plot_string,'#');
       if length(i) > 0
           nodes_flag = 1;
           j = strfind(prev_plot_string,'''');
           if length(j) < 2 | mod(length(j),2) ~= 0
               mssg = sprintf('Error:  the number of '' characters must be even and greater than 0');
               error_box(mssg,'Error in plot expression');
               return 
           end
           if (strncmp(prev_plot_string,'plot_psd',8) == 1 || ...
               strncmp(prev_plot_string,'plotsig',7) == 1)
               j = j(1:2);
           end

           h = prev_plot_string(j(length(j)-1)+1:j(length(j))-1);
           k = strfind(h,'#');
           if length(k) ~= length(i)
               mssg = sprintf('Error:  all ''#'' characters must be within the ''nodes'' expression');
               error_box(mssg,'Error in plot expression');
               return 
           end
           h(k(1)) = '$';
           cur_node_list = strrep(h,'$',cur_node);
           first_str = prev_plot_string(1:j(length(j)-1));
           last_str = prev_plot_string(j(length(j)):length(prev_plot_string));

           plot_string = sprintf('%s%s%s',first_str,cur_node_list,last_str);

           if strfind(plot_string,'#') > 0
              set(handles.edit_plot_entry,'String',plot_string);
              guidata(hObject,handles);
              return
           end
       else
          k = strfind(prev_plot_string,'node');
          if length(handles.plot_nodes) > 0 & length(k) == 0
             nodes_flag = 1;
             i = strfind(prev_plot_string,'''');
             if length(i) < 2 | mod(length(i),2) ~= 0
               mssg = sprintf('Error:  the number of '' characters must be even and greater than 0');
               error_box(mssg,'Error in plot expression');
               return 
             end
             if (strncmp(prev_plot_string,'plot_psd',8) == 1 || ...
                 strncmp(prev_plot_string,'plotsig',7) == 1)
                  i = i(1:2);
             end

             h = prev_plot_string(i(length(i)-1)+1:i(length(i))-1);
             first_str = prev_plot_string(1:i(length(i)-1));
             last_str = prev_plot_string(i(length(i)):length(prev_plot_string));
             if h(length(h)) == ';' | h(length(h)) == ','
                h = h(1:length(h)-1); 
             end
             cur_node_list = sprintf('%s;%s',h,cur_node);
          elseif length(k) > 0
             nodes_flag = 1;
             i = strfind(prev_plot_string,'''');
             if length(i) < 2 | mod(length(i),2) ~= 0
               mssg = sprintf('Error:  the number of '' characters must be even and greater than 0');
               error_box(mssg,'Error in plot expression');
               return 
             end
             if (strncmp(prev_plot_string,'plot_psd',8) == 1 || ...
                 strncmp(prev_plot_string,'plotsig',7) == 1)
                  i = i(1:2);
             end
             first_str = prev_plot_string(1:i(length(i)-1));
             last_str = prev_plot_string(i(length(i)):length(prev_plot_string));
             cur_node_list = cur_node;
          else
             plot_function_strings = cellstr(handles.plot_functions);
             cur_plot_function = plot_function_strings{handles.listbox_plot_function_index};
             i = strfind(cur_plot_function,'nodes');
             if i > 0
                nodes_flag = 1;
                first_str = cur_plot_function(1:i-1);
                last_str = cur_plot_function(i+5:length(cur_plot_function));
             else
                nodes_flag = 0;
                i = strfind(cur_plot_function,'node');
                if i <= 0
                   mssg = sprintf('Error:  there must be ''nodes'' or ''node'' present in plot function listbox description');
                   error_box(mssg,'Error in plot expression');
                   return 
                end
                first_str = cur_plot_function(1:i-1);
                last_str = cur_plot_function(i+4:length(cur_plot_function));
             end
             cur_node_list = cur_node;
          end
       end
       handles.plot_nodes = char(cur_node_list);

       plot_string = sprintf('%s%s%s',first_str,cur_node_list,last_str);

       flag_update = 0;

       if length(x_sig) > 1 & length(plot_string) > 0
          plot_string = clean_up_plot_string(plot_string);
          set(handles.edit_plot_entry,'String',plot_string);

          if strcmp(background_color,'yellow') == 1
             set(handles.listbox_shared,'BackgroundColor','cyan');
          else
             set(handles.listbox_shared,'BackgroundColor','yellow');
          end
          set(handles.edit_plot_entry,'Enable','off'); 
          pause(0.1);

          all_figures = get(0,'Children');
          if length(all_figures) == 1
              plot_fig_filename = sprintf('%s/MatlabGui/CppsimView/cppsimview_plot.fig',handles.root_dir);
              handles.fighandle = openfig(plot_fig_filename,'new');
              plot_fig_handles = guihandles(handles.fighandle);
              fHandle = plot_fig_handles.figure1;
              aHandle = plot_fig_handles.axes1;

              set(fHandle,'Visible','on');
              set(fHandle,'HandleVisibility','on');
              set(fHandle,'IntegerHandle','off');
              set(fHandle,'Name','Plot for CppsimView');
              set(fHandle,'NumberTitle','off');
              plot_axes_handle = aHandle;        
              handles.plot_handle = fHandle;        
          end

          %%%%%%%%%%%%% plot setup %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
          set(handles.fighandle,'Color',[0.0 0.0 0.0]);
          fig_handles = guihandles(handles.fighandle);

          color_order = [1 1 0; 1 0 1; 0 1 1; 1 0 0; 0 1 0; 0 0 1; .75 .75 .75];
          set(fig_handles.figure1,'DefaultAxesColorOrder',color_order);
          guidata(handles.fighandle,fig_handles);

          set(plot_axes_handle,'Color',[0.0 0.0 0.0]);
          set(plot_axes_handle,'XColor',[1.0 1.0 1.0]);
          set(plot_axes_handle,'YColor',[1.0 1.0 1.0]);
          set(plot_axes_handle,'LineWidth',1.5);
          axes(plot_axes_handle);
          guidata(hObject,handles);

          out = eval_plot_string(plot_string);

          if out == -1
             radio_messages_Callback(hObject, eventdata, handles);
             result_string = sprintf('Error:  %s',lasterr);
             set(handles.listbox_shared,'String',result_string);
             set(handles.listbox_shared,'Value',length(cellstr(result_string)));
             handles.cur_message = result_string;
          end

          flag_update = 1;

          global xzoom_flag
          if xzoom_flag == 1
             out = eval('xzoom','-1');
          end


          figure(handles.fighandle);
          plot_axes_handle = gca;

          set(handles.listbox_shared,'BackgroundColor',background_color);
          set(handles.edit_plot_entry,'Enable','on'); 
          guidata(hObject, handles);

       end

       if nodes_flag == 1
          set(handles.pushbutton_plot,'String','Reset Node List');
       else
          set(handles.pushbutton_plot,'String','Plot');
          handles.plot_nodes = [];
       end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
       if flag_update == 1
          test_par_file = get(handles.radio_test,'String');
          test_tr0_file = get(handles.radio_test_tr0,'String');
          index = handles.plot_history_index;
          new_command = plot_string;

          if index == 1
             handles.plot_history_buff{index,1} = test_par_file;
             handles.plot_history_buff{index,2} = test_tr0_file;
             handles.plot_history_buff{index,3} = new_command;

             handles.plot_history_index = index+1;
             handles.plot_history_scroll_index = index;
          else
             index_prev = index - 1;
             while index_prev > 0
                 if strcmp(handles.plot_history_buff{index_prev,1},test_par_file) == 1 & strcmp(handles.plot_history_buff{index_prev,2},test_tr0_file) == 1
                    break;
                 end
                 index_prev = index_prev - 1;
             end

             if index_prev == 0
                 handles.plot_history_buff{index,1} = test_par_file;
                 handles.plot_history_buff{index,2} = test_tr0_file;
                 handles.plot_history_buff{index,3} = new_command;
                 handles.plot_history_index = index+1;
                 handles.plot_history_scroll_index = index;
             elseif strcmp(handles.plot_history_buff{index_prev,3},new_command) ~= 1
                 handles.plot_history_buff{index,1} = test_par_file;
                 handles.plot_history_buff{index,2} = test_tr0_file;
                 handles.plot_history_buff{index,3} = new_command;
                 handles.plot_history_index = index+1;
                 handles.plot_history_scroll_index = index;
             end
          end

          if index == 430
              for i = 1:400
                 handles.plot_history_buff{i,1} = handles.plot_history_buff{i+30,1};
                 handles.plot_history_buff{i,2} = handles.plot_history_buff{i+30,2};
                 handles.plot_history_buff{i,3} = handles.plot_history_buff{i+30,3};
              end
              index = 400;
              handles.plot_history_index = index+1;
              handles.plot_history_scroll_index = index;
          end

       end

       % Update handles structure
%       guidata(hObject, handles);
   end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif handles.shared_listbox_flag == 5 %% hierarchy functions

    set(handles.edit_plot_entry,'String',name);

end

guidata(hObject, handles);

history.radio_test_string = get(handles.radio_test,'String');
history.radio_test_color = get(handles.radio_test,'ForegroundColor');
history.radio_test_tr0_string = get(handles.radio_test_tr0,'String');
history.radio_test_tr0_color = get(handles.radio_test_tr0,'ForegroundColor');
history.listbox_test_index = handles.listbox_test_index;
history.listbox_test_tr0_index = handles.listbox_test_tr0_index;
history.old_num_test_files = handles.old_num_test_files;
history.old_num_test_tr0_files = handles.old_num_test_tr0_files;

history.plot_history_buff = handles.plot_history_buff;
history.plot_history_index = handles.plot_history_index;
history.plot_history_scroll_index = handles.plot_history_scroll_index;
history.radio_plot_function = get(handles.radio_plot_function,'String');
history.plot_functions = handles.plot_functions;
history.listbox_plot_function_index = handles.listbox_plot_function_index;
history.plot_linewidth = plot_linewidth;
filename = sprintf('%s/CppsimView_history.mat',handles.cur_dir);
save(filename,'history');


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
function status = eval_plot_string(plot_string)

global title_string xlabel_string ylabel_string plot_linewidth
global x_sig


%#function plotsig_vpp, plot_xy, plot_fft, plot_fft_mag,plot_fft_db, plot_fft_db_mag, plot_fft_logx, plot_fft_logx_mag, plot_fft_db_logx, plot_fft_db_logx_mag, eyesig_vpp, eyesig_vpp_gmsk, scatter_eye_gmsk, plot_pll_phasenoise, plot_psd, plot_psd_sqrt, plot_psd_db, plot_pll_mod_spectrum, plot_pll_jitter, plot_pll_jitter_vs_time, loadsig_cppsim, mult, div, xzoom, close_req_function

status = -1;

j = 1;
expr = cell(10,1);
while 1
   start = 0;
   stop = 0;
   for i = 1:length(plot_string)
      if plot_string(i) == ''''
         start = i;
         break;
      end 
   end
   for i = start+1:length(plot_string)
      if plot_string(i) == ''''
         stop = i;
         break;
      end 
   end
   if start ~= 0 & stop ~= 0
      expr(j) = cellstr(plot_string(start:stop));
      new_expr = sprintf('#%d',j);
      plot_string = strrep(plot_string,char(expr(j)),new_expr);
      expr(j) = cellstr(strrep(char(expr(j)),'''',''));
      j = j+1;
   else
      break;
   end
end
plot_string = strrep(plot_string,' ','');

[func,r] = strtok(plot_string,'(');
r = strrep(r,'(','');
r = strrep(r,')','');

arg_num = 1;
arg = cell(20,1);
while 1
   [t,r] = strtok(r,',');
   if t(1) == '#'
      [t2,r2] = strtok(t,' #');
      expr_num = str2num(t2);
      arg(arg_num) = expr(expr_num);
   else
      arg(arg_num) = cellstr(t);
   end
   if length(r) == 0
      break;
   end
   arg_num = arg_num + 1;
end

switch func
   case 'plot_title'
      title_string = char(arg(1));
      deci_plot(1,1,3);
      status = 0;
      return;
   case 'plot_xlabel'
      xlabel_string = char(arg(1));
      deci_plot(1,1,3);
      status = 0;
      return;
   case 'plot_ylabel'
      ylabel_string = char(arg(1));
      deci_plot(1,1,3);
      status = 0;
      return;
   case 'plot_linewidth'
      temp = str2num(char(arg(1)));
      if length(temp) == 1
         plot_linewidth = temp;
      end
      deci_plot(1,1,3);
      status = 0;
      return;
   otherwise
      if strcmp(char(arg(1)),'x') == 0
         err_message = sprintf('Error: first argument must be ''x''');     
         error_box(err_message,'Error in Plot Expression');
         status = 0;
         return;
      end
end


for i = 2:arg_num
   if (strcmp(func,'plotsig') == 1)
       if (i == 3)
          if (strcmp(char(arg(3)),'logx') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'logy') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'logxy') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'loglog') == 1)
             continue;
          end
       end
   elseif (strcmp(func,'plot_psd') == 1)
       if (i == 3)
          if (strcmp(char(arg(3)),'logx') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'logy') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'logxy') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'loglog') == 1)
             continue;
          end
       end
   elseif (strcmp(func,'plot_psd_sqrt') == 1)
       if (i == 3)
          if (strcmp(char(arg(3)),'logx') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'logy') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'logxy') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'loglog') == 1)
             continue;
          end
       end
   elseif (strcmp(func,'plot_psd_db') == 1)
       if (i == 3)
          if (strcmp(char(arg(3)),'logx') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'logy') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'logxy') == 1)
             continue;
          elseif (strcmp(char(arg(3)),'loglog') == 1)
             continue;
          end
       end
   end

   [t,r] = strtok(char(arg(i)),',;');
   if length(r) == 0
      s = parse_expression(x_sig,char(arg(i)));
      if length(s) == 0
         status = 0;
         return;
      end
   end
end

func=regexprep(func,'plotsig','plotsig_vpp');
func=regexprep(func,'eyesig','eyesig_vpp');
if arg_num == 1
   feval(func,x_sig);
elseif arg_num == 2
   feval(func,x_sig,char(arg(2)));
elseif arg_num == 3
   feval(func,x_sig,char(arg(2)),char(arg(3)));
elseif arg_num == 4
   feval(func,x_sig,char(arg(2)),char(arg(3)),char(arg(4)));
elseif arg_num == 5
   feval(func,x_sig,char(arg(2)),char(arg(3)),char(arg(4)),char(arg(5)));
elseif arg_num == 6
   feval(func,x_sig,char(arg(2)),char(arg(3)),char(arg(4)),char(arg(5)),char(arg(6)));
elseif arg_num == 7
   feval(func,x_sig,char(arg(2)),char(arg(3)),char(arg(4)),char(arg(5)),char(arg(6)),char(arg(7)));
end

status = 0;


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5
function new_plot_string = clean_up_plot_string(plot_string)

new_plot_string = plot_string;
flag = 0;
while flag == 0
   flag = 1;
   if strfind(new_plot_string,';;') ~= -1 
       i = strfind(new_plot_string,';;');
       new_plot_string(i) = ' ';
       flag = 0;
   end
   if strfind(new_plot_string,',,') ~= -1 
       i = strfind(new_plot_string,',,');
       new_plot_string(i) = ' ';
       flag = 0;
   end
end
if strfind(new_plot_string,';'')') ~= -1 
    i = strfind(new_plot_string,';''');
    new_plot_string(i) = ' ';
end
if strfind(new_plot_string,','')') ~= -1 
    i = strfind(new_plot_string,',''');
    new_plot_string(i) = ' ';
end
if strfind(new_plot_string,'x,'';') ~= -1 
    i = strfind(new_plot_string,'x,'';');
    new_plot_string(i+3) = ' ';
end
if strfind(new_plot_string,'x,'',') ~= -1 
    i = strfind(new_plot_string,'x,'',');
    new_plot_string(i+3) = ' ';
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5



% --- Executes on button press in pushbutton_sue2_synch.
function pushbutton_sue2_synch_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_sue2_synch (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global message_lock_flag plot_linewidth x_sig

  if message_lock_flag ~= 0
     return
  end

all_figures = get(0,'Children');
if length(all_figures) == 1
        plot_fig_filename = sprintf('%s/MatlabGui/CppsimView/cppsimview_plot.fig',handles.root_dir);
        plot_fig = openfig(plot_fig_filename,'new');
        plot_fig_handles = guihandles(plot_fig);
        fHandle = plot_fig_handles.figure1;
        aHandle = plot_fig_handles.axes1;

        set(fHandle,'Visible','on');
        set(fHandle,'HandleVisibility','on');
        set(fHandle,'IntegerHandle','off');
        set(fHandle,'Name','Plot for CppsimView');
        set(fHandle,'NumberTitle','off');
        set(aHandle,'LineWidth',1.5);
        set(aHandle,'Color',[0.0 0.0 0.0]);
        set(aHandle,'XColor',[1.0 1.0 1.0]);
        set(aHandle,'YColor',[1.0 1.0 1.0]);
        set(fHandle,'Color',[0.0 0.0 0.0]);
        color_order = [1 1 0; 1 0 1; 0 1 1; 1 0 0; 0 1 0; 0 0 1; .75 .75 .75];
        set(fHandle,'DefaultAxesColorOrder',color_order);
        set(aHandle,'ColorOrder',color_order);

        guidata(plot_fig,plot_fig_handles);
        handles.fighandle = plot_fig;
        global plot_axes_handle;
        plot_axes_handle = aHandle;        
        handles.plot_handle = fHandle;        

        guidata(hObject, handles); 
end

set(handles.listbox_shared,'BackgroundColor','yellow');
pause(0.1);
set(handles.pushbutton_plot,'String','Plot');
handles.plot_nodes = [];

old_dir = handles.cur_dir;


% zip
temp_text = sprintf('%s/Netlist/netlist.cppsim',handles.home);
[cell,library] = get_current_cell_name(temp_text);
library_cellname = strcat(library,'/',cell);
if length(library) == 0
    disp('--> error:  cannot determine current cellview ...');
end

cur_dir = sprintf('%s/SimRuns/%s',handles.home,library_cellname);
handles.cur_dir = cur_dir;

[library_name,r] = strtok(library_cellname,'/');
cell_name = r(2:length(r));

%% check if directory must change
if strcmp(old_dir,handles.cur_dir)==0
   library_dir = sprintf('%s/SimRuns/%s',handles.home,library_name);

   if isdir(library_dir) == 0
     base_dir = sprintf('%s/SimRuns',handles.home);
%     cd(base_dir);
     run_program = sprintf('mkdir %s/%s',base_dir,library_name);
     [status] = unix(run_program);
   end
   if isdir(cur_dir) == 0
%     cd(library_dir);
     run_program = sprintf('mkdir %s/%s/%s',base_dir,library_name,cell_name);
     [status] = unix(run_program);
   end


%   cd(cur_dir);

   set(handles.radio_test,'Value',0);
   set(handles.listbox_shared,'String',[]);
   set(handles.listbox_shared,'Value',1);

   set(handles.pushbutton_edit_test_par,'String','Edit Sim File');

   set(handles.edit_plot_entry,'Enable','off'); 
   set(handles.edit_plot_entry,'BackgroundColor',[0.831,0.816,0.784]);
   set(handles.edit_plot_entry,'String','');

%   handles.copy_sim_file_name = [];
   handles.paste_sim_file_name = [];
   handles.copy_sim_file_name_candidate = [];
   handles.cur_message = ' ';
%   message_lock_flag = 0;
   handles.new_sim_file_name = [];



   set(handles.radio_nodes,'String','No Nodes');
   set(handles.radio_nodes,'ForegroundColor','red');
   handles.reload_nodes_flag = 1;

   x_sig = [];
   handles.shared_listbox_flag = 0;
   handles.listbox_test_index = 1;
   handles.listbox_test_tr0_index = 1;
   handles.listbox_nodes_index = 1;
   handles.old_num_test_tr0_files = 0;
   handles.old_num_nodes = 0;

   filename = sprintf('%s/CppsimView_history.mat',handles.cur_dir);
   fid = fopen(filename,'r');

   if fid ~= -1
      fclose(fid);
      try      
          history_root = load(filename);
      catch
          history_root = -1;
      end
      if isstruct(history_root) == 0
          error_box('History file was corrupted --- starting a new one','History Corrupted');
          file_status = -1;
      else
          history = history_root.history;
          file_status = check_history_file(history);
      end
   else
      file_status = -1;
   end
   if file_status == 0
      set(handles.radio_test,'String',history.radio_test_string);
      set(handles.radio_test,'ForegroundColor',history.radio_test_color);
      set(handles.radio_test_tr0,'String',history.radio_test_tr0_string);
      set(handles.radio_test_tr0,'ForegroundColor',history.radio_test_tr0_color);
      handles.listbox_test_index = history.listbox_test_index;
      handles.listbox_test_tr0_index = history.listbox_test_tr0_index;
      handles.old_num_test_files = history.old_num_test_files;
      handles.old_num_test_tr0_files = history.old_num_test_tr0_files;

      handles.plot_history_buff = history.plot_history_buff;
      handles.plot_history_index = history.plot_history_index;
      handles.plot_history_scroll_index = history.plot_history_scroll_index;
      set(handles.radio_plot_function,'String',history.radio_plot_function);
      handles.plot_functions = history.plot_functions;
      handles.listbox_plot_function_index = history.listbox_plot_function_index;
      plot_linewidth = history.plot_linewidth;
   else
      set(handles.radio_test,'String','No Sim File');
      set(handles.radio_test,'ForegroundColor','red');
      set(handles.radio_test_tr0,'String','No Output File');
      set(handles.radio_test_tr0,'ForegroundColor','red');
      handles.listbox_test_index = 1;
      handles.listbox_test_tr0_index = 1;
      handles.old_num_test_files = 0;
      handles.old_num_test_tr0_files = 0;

      handles.plot_history_buff{1,1}= ' '; 
      handles.plot_history_buff{1,2}= ' '; 
      handles.plot_history_buff{1,3}= ' '; 
      handles.plot_history_index = 1;
      handles.plot_history_scroll_index = 0;
      handles.listbox_plot_function_index = 1;
      set(handles.radio_plot_function,'String','plotsig(...)');
      handles.plot_functions = 'plotsig(x,''nodes'')';
      handles.plot_functions = strvcat(handles.plot_functions,'plot_xy(x,''x_sig'',''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_fft(x,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_mag(x,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_db(x,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_db_mag(x,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_logx(x,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_logx_mag(x,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_db_logx(x,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_fft_db_logx_mag(x,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'eyesig(x,period,start_off,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'eyesig_gmsk(x,period,start_off,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'scatter_eye_gmsk(x,symbol_rate,start_off,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_pll_phasenoise(x,f_low,f_high,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_psd(x,''nodes'',''logxy'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_psd_sqrt(x,''nodes'',''logxy'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_psd_db(x,''nodes'',''logx'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_pll_mod_spectrum(x,f_span,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_pll_jitter(x,''ref_timing_node'',start_edge,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_pll_jitter_vs_time(x,''ref_timing_node'',start_time,''nodes'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_title(''name'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_xlabel(''name'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_ylabel(''name'')');
      handles.plot_functions = strvcat(handles.plot_functions,'plot_linewidth(value)');

      plot_linewidth = 1.0;
   end
end


new_name = sprintf('Plot for CppsimView --- Library: %s, Cell: %s', library_name,cell_name);

set(handles.plot_handle,'Name',new_name);

new_name = sprintf('CppsimView --- Library: %s, Cell: %s', library_name,cell_name);

set(handles.main_handle,'Name',new_name);

set(handles.listbox_shared,'BackgroundColor','white');
pause(0.1);

guidata(hObject, handles);

radio_test_Callback(hObject, eventdata, handles)

%%%%% this is now used for 'Reload'
% --- Executes on button press in pushbutton_run_cppsim.
function pushbutton_run_cppsim_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_run_cppsim (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)


global background_color;
global message_lock_flag;

  if message_lock_flag ~= 0
     return
  end

handles.reload_nodes_flag = 1;
guidata(hObject, handles);
radio_nodes_Callback(hObject, eventdata, handles);



function list_select = listbox_select(result_string)

list_select = length(cellstr(result_string));
%%if list_select > 9
%%   list_select = list_select - 9;
%%else
%%   list_select = 1;
%%end


function result_string = breakup_string(result)

j = 1;
i_start = 1;

result_string = [];
for i = 1:length(result)
  if result(i) == 10
     result_string{j} = result(i_start:i-1);
     j = j + 1;
     i_start = i+1; 
  end
end




% --- Executes on button press in pushbutton_edit_modules.
function pushbutton_edit_modules_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_edit_modules (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

%% zip
if get(handles.radio_hierarchy,'Value') ~= 1
       error_box('You must first select hierarchy edit radio button and choose a module.','Error:  Need to select hierarchy radio button');
else
   index_selected = get(handles.listbox_shared,'Value');
   name_list = get(handles.listbox_shared,'String');
   name_cell = cellstr(name_list);

   cur_module_entry = name_cell{index_selected};

   [t,r] = strtok(cur_module_entry);
   if (strcmp(t,':') == 1)
       error_box('You need to select a module line that does not begin with :.','Error:  Need to select module');
   else
       [module_name,r] = strtok(r);
       [lib_name,r] = strtok(r);
       if lib_name(1) == '-'
          lib_name = strtok(lib_name,'-');
       else
          lib_name = '';
       end


       netlist_filename = sprintf('%s/Netlist/netlist.cppsim',handles.home);
       filename = get_current_module_filename(netlist_filename,module_name,lib_name);
       if t(1) == 'v'
          filename = strcat(filename,'/verilog/',module_name,'.v');
       else
          filename = strcat(filename,'/cppsim/','text.txt');
       end

       editor = getenv('EDITOR');
       if (length(editor) == 0)
          editor = 'emacs';
       end

       temp_text = sprintf('%s %s &',editor,filename);
%       temp_text = sprintf('c:/cppsim/cppsimshared/matlabgui/emacs-21.3/bin/%s %s &',editor,char(filename));
       [status] = unix(temp_text);
   end
end




% --- Executes on button press in pushbutton_edit_test_par.
function pushbutton_edit_test_par_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_edit_test_par (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

new_sim_file_name = [];

emacs_flag = 1;
if strcmp(get(handles.radio_test,'String'),'New Sim File') == 1
    if length(handles.new_sim_file_name) == 0
       new_sim_file_name = get(handles.edit_plot_entry,'String');
    else
       new_sim_file_name = handles.new_sim_file_name;
    end

    i = strfind(new_sim_file_name,'.par');
    flag = 0;
    if i > 0
       if i+3 ~= length(new_sim_file_name)
          flag = 1;
       end
    else
       flag = 1;
    end

    if flag == 1
        radio_messages_Callback(hObject, eventdata, handles);
        result_string = sprintf('Error:  Sim File must end in .par');
        set(handles.listbox_shared,'String',result_string);
        set(handles.listbox_shared,'Value',length(cellstr(result_string)));
        handles.cur_message = result_string;
        guidata(hObject, handles);
        return;
    else
        handles.new_sim_file_name = [];
    end

    full_filename = sprintf('%s/%s',handles.cur_dir,new_sim_file_name);
    fid = fopen(full_filename,'w');
    if fid == -1
       return;
    end

    home = char(handles.home);
    cur_dir = char(handles.cur_dir);
    temp_index = strfind(cur_dir,'SimRuns');
    base_names = cur_dir(temp_index+8:length(cur_dir));
    [library_name,r] = strtok(base_names,'/');
    cell_name = r(2:length(r));

    fprintf(fid,'/////////////////////////////////////////////////////////////\n');
    fprintf(fid,'// Cppsim Sim File: %s\n',new_sim_file_name);
    fprintf(fid,'// Cell: %s\n',cell_name);
    fprintf(fid,'// Library: %s\n',library_name);
    fprintf(fid,'/////////////////////////////////////////////////////////////\n\n');
    fprintf(fid,'// Simulator options:  cppsim, ncverilog, verilog\n');
    fprintf(fid,'simulator: cppsim\n\n');
    fprintf(fid,'// VCD file is optional and only generated for verilog\n');
    fprintf(fid,'vcd: out.vcd\n\n');
    fprintf(fid,'// Number of simulation time steps\n');
    fprintf(fid,'// Example: num_sim_steps: 10e3\n');
    fprintf(fid,'num_sim_steps: \n\n');
    fprintf(fid,'// Time step of simulator (in seconds)\n');
    fprintf(fid,'// Example: Ts: 1/10e9\n');
    fprintf(fid,'Ts: \n\n');
    [name_base,r] = strtok(new_sim_file_name,'.');
    fprintf(fid,'// Output File name\n');
    fprintf(fid,'// Example:  name below produces %s.tr0, %s.tr1, ...\n',name_base,name_base);
    fprintf(fid,'// Note: you can decimate, start saving at a given time offset, etc.\n');
    fprintf(fid,'//    -> See pages 34-35 of CppSim manual (i.e., output: section)\n');
    fprintf(fid,'output: %s\n\n',name_base);
    fprintf(fid,'// Nodes to be included in Output File\n');
    fprintf(fid,'// Example: probe: n0 n1 xi12.n3 xi14.xi12.n0\n');
    fprintf(fid,'probe: \n\n');
    fprintf(fid,'/////////////////////////////////////////////////////////////\n');
    fprintf(fid,'// Note:  Items below can be kept blank if desired\n');
    fprintf(fid,'/////////////////////////////////////////////////////////////\n\n');
    fprintf(fid,'// Values for global parameters used in schematic\n');
    fprintf(fid,'// Example: global_param: in_gl=92.1 delta_gl=0.0 step_time_gl=100e3*Ts\n');
    fprintf(fid,'global_param: \n\n');

    fprintf(fid,'// Rerun simulation with different global parameter values\n');
    fprintf(fid,'// Example: alter: in_gl = 90:2:98\n');
    fprintf(fid,'// See pages 37-38 of CppSim manual (i.e., alter: section)\n');
    fprintf(fid,'alter: \n');

    fclose(fid);
else
   new_sim_file_name = get(handles.radio_test,'String');
end

if strcmp(get(handles.radio_test,'String'),'No Sim File') ~= 1
   if emacs_flag == 1
       editor = getenv('EDITOR');
       if (length(editor) == 0)
          editor = 'emacs';
       end

       temp_text = sprintf('%s %s/%s &',editor,handles.cur_dir,new_sim_file_name);
%       temp_text = sprintf('c:/cppsim/cppsimshared/matlabgui/emacs-21.3/bin/%s %s/%s &',editor,handles.cur_dir,new_sim_file_name);
       [status] = unix(temp_text);
   end

   radio_test_Callback(hObject, eventdata, handles);

   name_list = get(handles.listbox_shared,'String');
   name_cell = cellstr(name_list);
   for i = 1:length(name_cell)
      if strcmp(name_cell{i},new_sim_file_name) == 1
          set(handles.listbox_shared,'Value',i);
          handles.listbox_test_index = i;
          handles.old_num_test_files = length(name_cell);
          set(handles.radio_test,'String',new_sim_file_name);
          set(handles.edit_plot_entry,'Enable','off'); 
          set(handles.edit_plot_entry,'BackgroundColor',[0.831,0.816,0.784]);
          set(handles.edit_plot_entry,'String','');
          break;
      end
   end

   % Update handles structure
   guidata(hObject, handles);

end

% --- Executes on button press in pushbutton_plot.
function pushbutton_plot_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_plot (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global background_color;
global message_lock_flag plot_linewidth;
global x_sig

  if message_lock_flag == 1
     return
  end
  if get(handles.radio_nodes,'Value') ~= 1
     return
  end


global plot_axes_handle;
command_string = get(handles.pushbutton_plot,'String');
flag_update = 0;

if strcmp(command_string,'Reset Node List') == 1
   handles.plot_nodes = [];
   set(handles.pushbutton_plot,'String','Plot');
   index = handles.listbox_plot_function_index;
   commands = cellstr(handles.plot_functions);
   command = char(commands(index));
   set(handles.edit_plot_entry,'String',command);
   guidata(hObject, handles);
else
   if strcmp(background_color,'yellow') == 1
      set(handles.listbox_shared,'BackgroundColor','cyan');
   else
      set(handles.listbox_shared,'BackgroundColor','yellow');
   end
   set(handles.edit_plot_entry,'Enable','off'); 
   pause(0.1);

   all_figures = get(0,'Children');
   if length(all_figures) == 1
        plot_fig_filename = sprintf('%s/MatlabGui/CppsimView/cppsimview_plot.fig',handles.root_dir);
        handles.fighandle = openfig(plot_fig_filename,'new');
        plot_fig_handles = guihandles(handles.fighandle);
        fHandle = plot_fig_handles.figure1;
        aHandle = plot_fig_handles.axes1;

        set(fHandle,'Visible','on');
        set(fHandle,'HandleVisibility','on');
        set(fHandle,'IntegerHandle','off');
        set(fHandle,'Name','Plot for CppsimView');
        set(fHandle,'NumberTitle','off');
        plot_axes_handle = aHandle;        
        handles.plot_handle = fHandle;        
   end

   %%%%%%%%%%%%% plot setup %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   set(handles.fighandle,'Color',[0.0 0.0 0.0]);
   fig_handles = guihandles(handles.fighandle);
   color_order = [1 1 0; 1 0 1; 0 1 1; 1 0 0; 0 1 0; 0 0 1; .75 .75 .75];
   set(fig_handles.figure1,'DefaultAxesColorOrder',color_order);
   guidata(handles.fighandle,fig_handles);

   set(plot_axes_handle,'Color',[0.0 0.0 0.0]);
   set(plot_axes_handle,'XColor',[1.0 1.0 1.0]);
   set(plot_axes_handle,'YColor',[1.0 1.0 1.0]);
   set(plot_axes_handle,'LineWidth',1.5);
   axes(plot_axes_handle);
   guidata(hObject,handles);

   plot_string = char(get(handles.edit_plot_entry,'String'));

   if length(x_sig) > 0 & length(plot_string) > 0 
      plot_string = clean_up_plot_string(plot_string);
      out = eval_plot_string(plot_string);

      if out == -1
          radio_messages_Callback(hObject, eventdata, handles);
          result_string = sprintf('Error:  %s',lasterr);
          set(handles.listbox_shared,'String',result_string);
          set(handles.listbox_shared,'Value',length(cellstr(result_string)));
          handles.cur_message = result_string;
      end
      flag_update = 1;

      global xzoom_flag
      if xzoom_flag == 1
         out = eval('xzoom','-1');
      end

   end
   figure(handles.fighandle);
   plot_axes_handle = gca;
   set(handles.listbox_shared,'BackgroundColor',background_color);
   set(handles.edit_plot_entry,'Enable','on'); 
   guidata(hObject, handles);

end

% Update handles structure
% guidata(hObject, handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if flag_update == 1
   test_par_file = get(handles.radio_test,'String');
   test_tr0_file = get(handles.radio_test_tr0,'String');
   index = handles.plot_history_index;
   new_command = plot_string;


   if index == 1
      handles.plot_history_buff{index,1} = test_par_file;
      handles.plot_history_buff{index,2} = test_tr0_file;
      handles.plot_history_buff{index,3} = new_command;

      handles.plot_history_index = index+1;
      handles.plot_history_scroll_index = index;
   else
      index_prev = index - 1;
      while index_prev > 0
      if strcmp(handles.plot_history_buff{index_prev,1},test_par_file) == 1 & strcmp(handles.plot_history_buff{index_prev,2},test_tr0_file) == 1
          break;
      end
          index_prev = index_prev - 1;
      end

      if index_prev == 0
          handles.plot_history_buff{index,1} = test_par_file;
          handles.plot_history_buff{index,2} = test_tr0_file;
          handles.plot_history_buff{index,3} = new_command;
          handles.plot_history_index = index+1;
          handles.plot_history_scroll_index = index;
      elseif strcmp(handles.plot_history_buff{index_prev,3},new_command) ~= 1
          handles.plot_history_buff{index,1} = test_par_file;
          handles.plot_history_buff{index,2} = test_tr0_file;
          handles.plot_history_buff{index,3} = new_command;
          handles.plot_history_index = index+1;
          handles.plot_history_scroll_index = index;
      end
   end

   if index == 430
       for i = 1:400
          handles.plot_history_buff{i,1} = handles.plot_history_buff{i+30,1};
          handles.plot_history_buff{i,2} = handles.plot_history_buff{i+30,2};
          handles.plot_history_buff{i,3} = handles.plot_history_buff{i+30,3};
       end
       index = 400;
       handles.plot_history_index = index+1;
       handles.plot_history_scroll_index = index;
   end

   history.radio_test_string = get(handles.radio_test,'String');
   history.radio_test_color = get(handles.radio_test,'ForegroundColor');
   history.radio_test_tr0_string = get(handles.radio_test_tr0,'String');
   history.radio_test_tr0_color = get(handles.radio_test_tr0,'ForegroundColor');
   history.listbox_test_index = handles.listbox_test_index;
   history.listbox_test_tr0_index = handles.listbox_test_tr0_index;
   history.old_num_test_files = handles.old_num_test_files;
   history.old_num_test_tr0_files = handles.old_num_test_tr0_files;

   history.plot_history_buff = handles.plot_history_buff;
   history.plot_history_index = handles.plot_history_index;
   history.plot_history_scroll_index = handles.plot_history_scroll_index;
   history.radio_plot_function = get(handles.radio_plot_function,'String');
   history.plot_functions = handles.plot_functions;
   history.listbox_plot_function_index = handles.listbox_plot_function_index;
   history.plot_linewidth = plot_linewidth;
   filename = sprintf('%s/CppsimView_history.mat',handles.cur_dir);
   save(filename,'history');

end

% Update handles structure
guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5



% --- Executes on button press in pushbutton_back.
function pushbutton_back_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_back (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global message_lock_flag;

if message_lock_flag == 1
   return
end

if handles.plot_history_scroll_index  == 0
   return
end

cur_command = get(handles.edit_plot_entry,'String');

if strcmp(get(handles.pushbutton_plot,'String'),'Reset Node List') == 1 & ...
   length(cur_command) > 0
    handles.plot_nodes = [];
    set(handles.pushbutton_plot,'String','Plot');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
test_par_file = get(handles.radio_test,'String');
test_tr0_file = get(handles.radio_test_tr0,'String');

index = handles.plot_history_scroll_index;
if index == handles.plot_history_index-1
%    cur_command = get(handles.edit_plot_entry,'String');
    cur_buf = handles.plot_history_buff{index,3};
    if strcmp(cur_command,cur_buf) == 1
        index = index - 1;
    end
else
   index = index - 1;
end

while 1
   if index <= 1
      index = 1;
      flag = 0;
      if strcmp(handles.plot_history_buff{index,1},test_par_file) ~= 1
         flag = 1;
      elseif strcmp(handles.plot_history_buff{index,2},test_tr0_file) ~= 1
         flag = 1;
      end
      if flag == 1
         command =  char(get(handles.edit_plot_entry,'String'));
      else
         command = handles.plot_history_buff{index,3};
         handles.plot_history_scroll_index = index;
      end
      break;
   else
      flag = 0;
      if strcmp(handles.plot_history_buff{index,1},test_par_file) ~= 1
         flag = 1;
      elseif strcmp(handles.plot_history_buff{index,2},test_tr0_file) ~= 1
         flag = 1;
      end
      if flag == 1
         index = index - 1;
         continue;
      else
         command = handles.plot_history_buff{index,3};
         handles.plot_history_scroll_index = index;
         break;
      end
   end
end

set(handles.edit_plot_entry,'String',command);

guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5



% --- Executes on button press in pushbutton_forward.
function pushbutton_forward_Callback(hObject, eventdata, handles)
% hObject    handle to pushbutton_forward (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global message_lock_flag;

if message_lock_flag == 1
    return
end

if strcmp(get(handles.pushbutton_plot,'String'),'Reset Node List') == 1
    handles.plot_nodes = [];
    set(handles.pushbutton_plot,'String','Plot');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
test_par_file = get(handles.radio_test,'String');
test_tr0_file = get(handles.radio_test_tr0,'String');
index = handles.plot_history_scroll_index + 1;
last_index = handles.plot_history_index;

while 1
   if index >= last_index
      index = last_index-1;
      if last_index > 1
         flag = 0;
         if strcmp(handles.plot_history_buff{index,1},test_par_file) ~= 1
            flag = 1;
         elseif strcmp(handles.plot_history_buff{index,2},test_tr0_file) ~= 1
            flag = 1;
         end
         if flag == 1
            command = char(get(handles.edit_plot_entry,'String'));
         else
            command = handles.plot_history_buff{index,3};
            handles.plot_history_scroll_index = index;
         end
      else
         flag = 0;
         if strcmp(handles.plot_history_buff{1,1},test_par_file) ~= 1
            flag = 1;
         elseif strcmp(handles.plot_history_buff{1,2},test_tr0_file) ~= 1
            flag = 1;
         end
         if flag == 1
            command = char(get(handles.edit_plot_entry,'String'));
         else
            command = handles.plot_history_buff{1,3};
            handles.plot_history_scroll_index = 1;
         end
      end
      break;
   else
      flag = 0;
      if strcmp(handles.plot_history_buff{index,1},test_par_file) ~= 1
         flag = 1;
      elseif strcmp(handles.plot_history_buff{index,2},test_tr0_file) ~= 1
         flag = 1;
      end
      if flag == 1
         index = index + 1;
         continue;
      else
         command = handles.plot_history_buff{index,3};
         handles.plot_history_scroll_index = index;
         break;
      end
   end
end


set(handles.edit_plot_entry,'String',command);

guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5




% --- Executes on button press in radio_test.
function radio_plot_function_Callback(hObject, eventdata, handles)
% hObject    handle to radio_plot_function (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_plot_function

global message_lock_flag;

  if message_lock_flag == 1
     set(handles.radio_plot_function,'Value',0);
     guidata(hObject, handles);
     return
  end

  off = [handles.radio_test,handles.radio_test_tr0,handles.radio_nodes,handles.radio_messages,handles.radio_hierarchy];
  mutual_exclusive(off)
  set(handles.radio_plot_function,'Value',1);

  handles.shared_listbox_flag = 2;

  if strcmp(get(handles.pushbutton_plot,'String'),'Reset Node List') == 1
        handles.plot_nodes = [];
        set(handles.pushbutton_plot,'String','Plot');
  end

  plot_function_strings = cellstr(handles.plot_functions);
  cur_plot_function = plot_function_strings{handles.listbox_plot_function_index};

  set(handles.listbox_shared,'String',plot_function_strings);
  set(handles.listbox_shared,'Value',handles.listbox_plot_function_index);

  [base,r] = strtok(cur_plot_function,'(');
  switch base
        case 'plot_title'
        case 'plot_xlabel'
        case 'plot_ylabel'
        case 'plot_linewidth'
        otherwise
           base = sprintf('%s(...)',base);
           set(handles.radio_plot_function,'String',base);
  end

  set(handles.edit_plot_entry,'Enable','on'); 
  set(handles.edit_plot_entry,'BackgroundColor',[1.0,1.0,1.0]);
  set(handles.edit_plot_entry,'String',cur_plot_function);

  guidata(hObject, handles);

% --- Executes on button press in radio_test.
function radio_test_Callback(hObject, eventdata, handles)
% hObject    handle to radio_test (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_test

global message_lock_flag;

  if message_lock_flag ~= 0
     set(handles.radio_test,'Value',0);
     guidata(hObject, handles);
     return
  end

  off = [handles.radio_test_tr0,handles.radio_nodes,handles.radio_plot_function,handles.radio_messages,handles.radio_hierarchy];
  mutual_exclusive(off)
  set(handles.radio_test,'Value',1);


  test_par_list = get_test_par_filenames(handles);
  new_num_files = length(cellstr(test_par_list));

  set(handles.listbox_shared,'String',test_par_list);
  if new_num_files ~= handles.old_num_test_files
     set(handles.listbox_shared,'Value',1);
  else
     set(handles.listbox_shared,'Value',handles.listbox_test_index);
  end

  handles.old_num_test_files = new_num_files;

%% set selected test.par name on radio button
  handles.shared_listbox_flag = 0;

  index_selected = get(handles.listbox_shared,'Value');
  name_list = get(handles.listbox_shared,'String');
  name_cell = cellstr(name_list);
  name = name_cell{index_selected};

  set(handles.radio_test,'String',name);

  if strcmp(name,'New Sim File') == 1
      set(handles.radio_test,'ForegroundColor','red');
      set(handles.pushbutton_edit_test_par,'String','Create Sim File');  
      set(handles.edit_plot_entry,'Enable','on'); 
      set(handles.edit_plot_entry,'BackgroundColor',[1.0,1.0,1.0]);
      if length(handles.new_sim_file_name) == 0
         set(handles.edit_plot_entry,'String','test.par');
      else
         set(handles.edit_plot_entry,'String',handles.new_sim_file_name);
      end
  else
      set(handles.radio_test,'ForegroundColor','black');
      set(handles.pushbutton_edit_test_par,'String','Edit Sim File');
      set(handles.edit_plot_entry,'Enable','off'); 
      set(handles.edit_plot_entry,'BackgroundColor',[0.831,0.816,0.784]);
      set(handles.edit_plot_entry,'String','');
  end

  guidata(hObject, handles);




% --- Gets test.par file names
function file_list = get_test_par_filenames(handles)

   file_list = {};
   dir_list = dir(handles.cur_dir);
   num_files = length(dir_list);

   for i = 1:num_files
      k = strfind(dir_list(i).name,'.par');
      if k >= 1
         if length(dir_list(i).name) > k+3
            continue;
         end
         file_list = strvcat(dir_list(i).name,file_list);
      end
   end
   file_list = sortrows(file_list);

   file_list = strvcat(file_list,'New Sim File');

% --- Gets test.tr0 file names
function file_list = get_test_tr0_filenames(handles)

   file_list = {};
   dir_list = dir(handles.cur_dir);
   num_files = length(dir_list);

   if strcmp(get(handles.radio_test,'String'),'New Sim File') == 1
       error_box('You must select (or create and then select) a simulation file before you can choose an associated output file.','Error:  No Simulation File');
       return;
   end
   [test_par_name,r] = strtok(char(get(handles.radio_test,'String')),'.');
   test_tr0_list_name = sprintf('%s/%s.outfile_list',handles.cur_dir,test_par_name);
   
   fid = fopen(test_tr0_list_name);
   if fid == -1
       error_box('You must run CppSim on the simulation file before you can choose an associated output file.','Error:  Simulation File Needs to be Run');
       return;      
   end
   while 1
       test_tr0_name = fgetl(fid);
       if ~ischar(test_tr0_name)
          break
       end
       test_tr0_name = sprintf('%s.tr',test_tr0_name);
       for i = 1:num_files
          if strfind(dir_list(i).name,test_tr0_name) >= 1
             file_list = strvcat(dir_list(i).name,file_list);
          end
       end
   end
   fclose(fid);

   file_list = sortrows(file_list);

% --- Executes on button press in radio_test_tr0.
function radio_test_tr0_Callback(hObject, eventdata, handles)
% hObject    handle to radio_test_tr0 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_test_tr0

global message_lock_flag;

  if message_lock_flag == 1
     set(handles.radio_test_tr0,'Value',0);
     guidata(hObject, handles);
     return
  end

  off = [handles.radio_test,handles.radio_nodes,handles.radio_plot_function,handles.radio_messages,handles.radio_hierarchy];
  mutual_exclusive(off)
  set(handles.radio_test_tr0,'Value',1);

  handles.shared_listbox_flag = 1;


  test_tr0_list = get_test_tr0_filenames(handles);
  if ischar(test_tr0_list) == 0
     test_tr0_list = 'No Output File';
  end

  new_num_files = length(cellstr(test_tr0_list));

  set(handles.listbox_shared,'String',test_tr0_list);
  if new_num_files ~= handles.old_num_test_tr0_files
     set(handles.listbox_shared,'Value',1);
     handles.listbox_test_tr0_index = 1;
  else
     set(handles.listbox_shared,'Value',handles.listbox_test_tr0_index);
  end

  handles.old_num_test_tr0_files = new_num_files;

%% set selected test.tr0 name on radio button

  index_selected = get(handles.listbox_shared,'Value');
  name_list = get(handles.listbox_shared,'String');
  name_cell = cellstr(name_list);
  name = name_cell{index_selected};

  set(handles.radio_test_tr0,'String',name);

  if strcmp(name,'No Output File') == 1
      set(handles.radio_test_tr0,'ForegroundColor','red');  
  else
      set(handles.radio_test_tr0,'ForegroundColor','black');
  end

  set(handles.edit_plot_entry,'Enable','off'); 
  set(handles.edit_plot_entry,'BackgroundColor',[0.831,0.816,0.784]);
  set(handles.edit_plot_entry,'String','');

  guidata(hObject, handles);


% --- Executes on button press in radio_nodes.
function radio_nodes_Callback(hObject, eventdata, handles)
% hObject    handle to radio_nodes (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_nodes

  global background_color;
  global message_lock_flag;
  global prev_message;
  global x_sig
  global change_function_flag;

  if message_lock_flag == 1
      set(handles.radio_nodes,'Value',0);
      guidata(hObject, handles);
      return
  elseif message_lock_flag == 2
      handles.reload_nodes_flag = 1;
      sim_file = get(handles.radio_test,'String');
      status = check_run_file(handles.home,handles.cur_dir,sim_file);
      if status == 0
         message_lock_flag = 0;
         message_filename = sprintf('%s_message.out',strtok(sim_file,'.'));
         result = get_output_message(message_filename);
         handles.cur_message = strvcat(prev_message,result);
         set(handles.listbox_shared,'BackgroundColor','white');
         background_color = 'white';
         guidata(hObject, handles);
         pause(0.1);
      end
  end


  if strcmp(get(handles.radio_test_tr0,'String'),'No Output File') == 1

     error_box('You must select an output file before you can load its nodes.','Error:  No Output File');

     set(handles.radio_nodes,'Value',0);
     set(handles.radio_nodes,'String','No Nodes');
     set(handles.radio_nodes,'ForegroundColor','red');
     if strcmp(get(handles.pushbutton_plot,'String'),'Reset Node List') == 1
         handles.plot_nodes = [];
         set(handles.pushbutton_plot,'String','Plot');
     end

     handles.reload_nodes_flag = 1;
     guidata(hObject, handles);
     return
  end

  off = [handles.radio_test,handles.radio_test_tr0,handles.radio_plot_function,handles.radio_messages,handles.radio_hierarchy];
  mutual_exclusive(off)
  set(handles.radio_nodes,'Value',1);


  if handles.reload_nodes_flag == 1
     if strcmp(background_color,'yellow') == 1
        set(handles.listbox_shared,'BackgroundColor','cyan');
     else
        set(handles.listbox_shared,'BackgroundColor','yellow');
     end
     test_tr0_filename = get(handles.radio_test_tr0,'String');
     full_filename = sprintf('%s/%s',handles.cur_dir,test_tr0_filename);
     dir_struct = dir(full_filename);
     temp = sprintf('... Loading Nodes:  ---  x = loadsig_cppsim(''%s'');  ---  ... (File Size:  %5.2f MegaBytes)',test_tr0_filename,dir_struct.bytes/1e6);
     set(handles.listbox_shared,'String',temp);
     set(handles.listbox_shared,'Value',1);
     set(handles.edit_plot_entry,'Enable','off'); 
     pause(0.1);

     test_tr_file = get(handles.radio_test_tr0,'String');
     full_filename = sprintf('%s/%s',handles.cur_dir,test_tr_file);
     clear x_sig;
     global x_sig;
     try
          x_sig = loadsig_cppsim(full_filename);
     catch
          x_sig = -1;
     end

     if isstruct(x_sig) == 0
          radio_messages_Callback(hObject, eventdata, handles);
%          result_string = sprintf('Error:  %s',lasterr);
          result_string = sprintf('Error:  loadsig_cppsim could not open file ''%s''',test_tr_file);
          set(handles.listbox_shared,'String',result_string);
          set(handles.listbox_shared,'Value',length(cellstr(result_string)));
          handles.cur_message = result_string;
          x_sig = [];
          guidata(hObject, handles);
          return;
      end

     handles.reload_nodes_flag = 0;

     set(handles.listbox_shared,'BackgroundColor',background_color);
     set(handles.edit_plot_entry,'Enable','on'); 
     guidata(hObject, handles);
     pause(0.1);

  end

  node_list = strvcat(x_sig(1:length(x_sig)).name);
  set(handles.listbox_shared,'String',node_list);

  handles.shared_listbox_flag = 3;
  node_cell_list = cellstr(node_list);
  new_num_nodes = length(node_cell_list);

  if new_num_nodes ~= handles.old_num_nodes
     set(handles.listbox_shared,'Value',1);
  else
     string_list = get(handles.listbox_shared,'String');
     if handles.listbox_nodes_index <= length(cellstr(string_list))
        set(handles.listbox_shared,'Value',handles.listbox_nodes_index);
     else
        set(handles.listbox_shared,'Value',1);
     end
  end

  handles.old_num_nodes = new_num_nodes;

  set(handles.radio_nodes,'String','nodes');
  set(handles.radio_nodes,'ForegroundColor','black');

  guidata(hObject, handles);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
test_par_file = get(handles.radio_test,'String');
test_tr0_file = get(handles.radio_test_tr0,'String');
index = handles.plot_history_index-1;

while 1
   if index < 1
      command = '';
      handles.plot_history_scroll_index = index;
      break;
   else
      flag = 0;
      if strcmp(handles.plot_history_buff{index,1},test_par_file) ~= 1
         flag = 1;
      elseif strcmp(handles.plot_history_buff{index,2},test_tr0_file) ~= 1
         flag = 1;
      end
      if flag == 1
         index = index - 1;
         continue;
      else
         command = handles.plot_history_buff{index,3};
         handles.plot_history_scroll_index = index;
         break;
      end
   end
end

set(handles.edit_plot_entry,'Enable','on'); 
set(handles.edit_plot_entry,'BackgroundColor',[1.0,1.0,1.0]);

command = get(handles.edit_plot_entry,'String');
if length(command) == 0 & change_function_flag == 1
    change_function_flag = 0;
    index = handles.listbox_plot_function_index;
    commands = cellstr(handles.plot_functions);
    command = char(commands(index));
    set(handles.edit_plot_entry,'String',command);
elseif length(command) == 0
    pushbutton_back_Callback(hObject,eventdata,handles);
end

guidata(hObject, handles);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%5

global plot_title_name
cur_dir = handles.cur_dir;
temp_index = strfind(cur_dir,'SimRuns');
base_names = cur_dir(temp_index+8:length(cur_dir));
[library_name,r] = strtok(base_names,'/');
cell_name = r(2:length(r));
sim_file = get(handles.radio_test,'String');

plot_title_name = sprintf('Cell: %s, Lib: %s, Sim: %s',cell_name,library_name,sim_file);


% --- Executes on button press in radio_nodes.
function radio_messages_Callback(hObject, eventdata, handles)
% hObject    handle to radio_messages (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_nodes

  global background_color;
  global message_lock_flag;
  global prev_message;

  handles.shared_listbox_flag = 4;
  if message_lock_flag == 1
      set(handles.radio_messages,'Value',1);
      guidata(hObject, handles);
      return
  elseif message_lock_flag == 2
      handles.reload_nodes_flag = 1;
      sim_file = get(handles.radio_test,'String');
      status = check_run_file(handles.home,handles.cur_dir,sim_file);
      if status == 0
         message_lock_flag = 0;
         message_filename = sprintf('%s_message.out',strtok(sim_file,'.'));
         result = get_output_message(message_filename);
         handles.cur_message = strvcat(prev_message,result);
         set(handles.listbox_shared,'BackgroundColor','white');
         background_color = 'white';
         guidata(hObject, handles);
         pause(0.1);
      end
  end

  off = [handles.radio_test,handles.radio_test_tr0,handles.radio_plot_function,handles.radio_messages,handles.radio_nodes,handles.radio_hierarchy];
  mutual_exclusive(off);
  set(handles.radio_messages,'Value',1);

  set(handles.listbox_shared,'String',char(handles.cur_message));
  set(handles.listbox_shared,'Value',listbox_select(handles.cur_message));

  set(handles.edit_plot_entry,'Enable','off'); 
  set(handles.edit_plot_entry,'BackgroundColor',[0.831,0.816,0.784]);
  set(handles.edit_plot_entry,'String','');

  guidata(hObject, handles);

% --- Executes on button press in radio_nodes.
function radio_hierarchy_Callback(hObject, eventdata, handles)
% hObject    handle to radio_messages (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hint: get(hObject,'Value') returns toggle state of radio_nodes

  global background_color;
  global message_lock_flag;
  global prev_message;

  handles.shared_listbox_flag = 5; 
  if message_lock_flag == 1
      set(handles.radio_hierarchy,'Value',1);
      guidata(hObject, handles);
      return
  elseif message_lock_flag == 2
      handles.reload_nodes_flag = 1;
      sim_file = get(handles.radio_test,'String');
      status = check_run_file(handles.home,handles.cur_dir,sim_file);
      if status == 0
         message_lock_flag = 0;
         message_filename = sprintf('%s_message.out',strtok(sim_file,'.'));
         result = get_output_message(message_filename);
         handles.cur_message = strvcat(prev_message,result);
         set(handles.listbox_shared,'BackgroundColor','white');
         background_color = 'white';
         guidata(hObject, handles);
         pause(0.1);
      end
  end

  off = [handles.radio_test,handles.radio_test_tr0,handles.radio_plot_function,handles.radio_messages,handles.radio_nodes,handles.radio_hierarchy];
  mutual_exclusive(off);
  set(handles.radio_hierarchy,'Value',1);

  set(handles.edit_plot_entry,'Enable','off'); 
  set(handles.edit_plot_entry,'BackgroundColor',[0.831,0.816,0.784]);
  set(handles.edit_plot_entry,'String','');

  guidata(hObject, handles);

home = char(handles.home);
cur_dir = char(handles.cur_dir);
parfile = char(get(handles.radio_test,'String'));

message_filename = sprintf('%s_message.out',strtok(parfile,'.'));

%run_program = sprintf('%s/bin/net2code -hier_v %s/%s >! %s/%s', handles.root_dir,handles.cur_dir, strtok(parfile,'.'), handles.cur_dir, message_filename);
run_program = sprintf('%s/bin/net2code -hier_v %s/%s',handles.root_dir,handles.cur_dir, strtok(parfile,'.'));
[status] = unix(run_program);
result = get_output_message(message_filename);
handles.cur_message = result; 

% radio_messages_Callback(hObject, eventdata, handles);

message_filename = sprintf('%s/%s.hier_v',handles.cur_dir,strtok(parfile,'.'));
result = get_output_message(message_filename);
result_string = result;

set(handles.listbox_shared,'String',result_string);
% set(handles.listbox_shared,'Value',length(cellstr(result_string)));
set(handles.listbox_shared,'Value',1);
guidata(hObject, handles);
% zip

index_selected = get(handles.listbox_shared,'Value');
name_list = get(handles.listbox_shared,'String');
name_cell = cellstr(name_list);
if (index_selected <= length(name_cell))
   cur_hier_line = name_cell{index_selected};
else
   cur_hier_line = 'Error:  click on messages radio button to view';
end
set(handles.edit_plot_entry,'Enable','on'); 
set(handles.edit_plot_entry,'BackgroundColor',[1.0,1.0,1.0]);
set(handles.edit_plot_entry,'String',cur_hier_line);

guidata(hObject, handles);


% --- Executes on button press in entry form
function edit_plot_entry_Callback(hObject, eventdata, handles)
% hObject    handle to plot_entry (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global plot_axes_handle;
global background_color plot_linewidth;
global x_sig;

if get(handles.radio_test,'Value') == 1
   if strcmp(get(handles.radio_test,'String'),'New Sim File') == 1
      handles.new_sim_file_name = char(get(handles.edit_plot_entry,'String'));
      handles.copy_sim_file_name = [];
      handles.paste_sim_file_name = [];
   end
   guidata(hObject, handles);
%%   pushbutton_edit_test_par_Callback(hObject, eventdata, handles);
elseif get(handles.radio_plot_function,'Value') == 1

   index_selected = get(handles.listbox_shared,'Value');
   name_list = get(handles.listbox_shared,'String');
   name_cell = cellstr(name_list);
   new_plot_name = char(get(handles.edit_plot_entry,'String'));

   [base,r] = strtok(new_plot_name,'(');
   switch base
        case 'plot_title'
        case 'plot_xlabel'
        case 'plot_ylabel'
        case 'plot_linewidth'
        otherwise
           if length(strfind(new_plot_name,'''node''')) == 0 & ...
              length(strfind(new_plot_name,'''nodes''')) == 0
               mssg = sprintf('Error:  plot expressions must contain either ''node'' or ''nodes''');
               error_box(mssg,'Error in plot expression');
               return 
           end
   end

   name_cell{index_selected} = new_plot_name;
   handles.plot_functions = name_cell;

   set(handles.listbox_shared,'String',name_cell);

   [base,r] = strtok(new_plot_name,'(');
   switch base
        case 'plot_title'
        case 'plot_xlabel'
        case 'plot_ylabel'
        case 'plot_linewidth'
        otherwise
           base = sprintf('%s(...)',base);
           set(handles.radio_plot_function,'String',base);
   end
 
   guidata(hObject,handles);

   history.radio_test_string = get(handles.radio_test,'String');
   history.radio_test_color = get(handles.radio_test,'ForegroundColor');
   history.radio_test_tr0_string = get(handles.radio_test_tr0,'String');
   history.radio_test_tr0_color = get(handles.radio_test_tr0,'ForegroundColor');
   history.listbox_test_index = handles.listbox_test_index;
   history.listbox_test_tr0_index = handles.listbox_test_tr0_index;
   history.old_num_test_files = handles.old_num_test_files;
   history.old_num_test_tr0_files = handles.old_num_test_tr0_files;

   history.plot_history_buff = handles.plot_history_buff;
   history.plot_history_index = handles.plot_history_index;
   history.plot_history_scroll_index = handles.plot_history_scroll_index;
   history.radio_plot_function = get(handles.radio_plot_function,'String');
   history.plot_functions = handles.plot_functions;
   history.listbox_plot_function_index = handles.listbox_plot_function_index;
   history.plot_linewidth = plot_linewidth;
   filename = sprintf('%s/CppsimView_history.mat',handles.cur_dir);
   save(filename,'history');

elseif get(handles.radio_hierarchy,'Value') == 1

   index_selected = get(handles.listbox_shared,'Value');
   name_list = get(handles.listbox_shared,'String');
   name_cell = cellstr(name_list);
   new_hierarchy_name = char(get(handles.edit_plot_entry,'String'));

   name_cell{index_selected} = new_hierarchy_name;

   set(handles.listbox_shared,'String',name_cell);
 
   guidata(hObject,handles);

   parfile = char(get(handles.radio_test,'String'));
 
   message_filename = sprintf('%s/%s.hier_v',handles.cur_dir,strtok(parfile,'.'));

   status = send_string_list_to_file(name_cell,message_filename);

   if (status == 0)
      mssg = sprintf('Error using send_string_list_file function');
      uiwait(msgbox(mssg,'Error using send_string_list_file function','modal'));
      close_req_function;
      return
   end

   message_filename = sprintf('%s_message.out',strtok(parfile,'.'));
%   run_program = sprintf('%s/bin/net2code -hier_v %s/%s >! %s/%s',handles.root_dir,handles.cur_dir, strtok(parfile,'.'), handles.cur_dir, message_filename);
   run_program = sprintf('%s/bin/net2code -hier_v %s/%s',handles.root_dir,handles.cur_dir, strtok(parfile,'.'));
   [status] = unix(run_program);
   result = get_output_message(message_filename);
   handles.cur_message = result; 

   % radio_messages_Callback(hObject, eventdata, handles);

   message_filename = sprintf('%s/%s.hier_v',handles.cur_dir,strtok(parfile,'.'));
   result = get_output_message(message_filename);
   result_string = result;

   set(handles.listbox_shared,'String',result_string);
   guidata(hObject,handles);

%%% zip

elseif get(handles.radio_nodes,'Value') == 1

   prev_plot_string = char(get(handles.edit_plot_entry,'String'));
   if strfind(prev_plot_string,'#') > 0
       return
   end
   

   index_selected = get(handles.listbox_shared,'Value');
   name_list = get(handles.listbox_shared,'String');
   name_cell = cellstr(name_list);
   name = name_cell{index_selected};

   if strcmp(background_color,'yellow') == 1
      set(handles.listbox_shared,'BackgroundColor','cyan');
   else
      set(handles.listbox_shared,'BackgroundColor','yellow');
   end
   set(handles.edit_plot_entry,'Enable','off'); 
   pause(0.1);

%%% zippy
   all_figures = get(0,'Children');
   if length(all_figures) == 1
        plot_fig_filename = sprintf('%s/MatlabGui/CppsimView/cppsimview_plot.fig',handles.root_dir);
        handles.fighandle = openfig(plot_fig_filename,'new');
        plot_fig_handles = guihandles(handles.fighandle);
        fHandle = plot_fig_handles.figure1;
        aHandle = plot_fig_handles.axes1;

        set(fHandle,'Visible','on');
        set(fHandle,'HandleVisibility','on');
        set(fHandle,'IntegerHandle','off');
        set(fHandle,'Name','Plot for CppsimView');
        set(fHandle,'NumberTitle','off');
        plot_axes_handle = aHandle;        
        handles.plot_handle = fHandle;        
   end

   %%%%%%%%%%%%% plot setup %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   set(handles.fighandle,'Color',[0.0 0.0 0.0]);
   fig_handles = guihandles(handles.fighandle);
   color_order = [1 1 0; 1 0 1; 0 1 1; 1 0 0; 0 1 0; 0 0 1; .75 .75 .75];
   set(fig_handles.figure1,'DefaultAxesColorOrder',color_order);
   guidata(handles.fighandle,fig_handles);

   set(plot_axes_handle,'Color',[0.0 0.0 0.0]);
   set(plot_axes_handle,'XColor',[1.0 1.0 1.0]);
   set(plot_axes_handle,'YColor',[1.0 1.0 1.0]);
   set(plot_axes_handle,'LineWidth',1.5);
   axes(plot_axes_handle);
   guidata(hObject,handles);

   plot_string = char(get(handles.edit_plot_entry,'String'));
   flag_update = 0;

   if length(x_sig) > 0 & length(plot_string) > 0 
      plot_string = clean_up_plot_string(plot_string);

      out = eval_plot_string(plot_string);
      if out == -1
          radio_messages_Callback(hObject, eventdata, handles);
          result_string = sprintf('Error:  %s',lasterr);
          set(handles.listbox_shared,'String',result_string);
          set(handles.listbox_shared,'Value',length(cellstr(result_string)));
          handles.cur_message = result_string;
      end
      flag_update = 1;

      global xzoom_flag
      if xzoom_flag == 1
          out = eval('xzoom','-1');
      end

   end
   figure(handles.fighandle);
   plot_axes_handle = gca;
   set(handles.listbox_shared,'BackgroundColor',background_color);
   set(handles.edit_plot_entry,'Enable','on'); 
   guidata(hObject,handles);

   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   if flag_update == 1
      test_par_file = get(handles.radio_test,'String');
      test_tr0_file = get(handles.radio_test_tr0,'String');
      index = handles.plot_history_index;
      new_command = plot_string;



      if index == 1
         handles.plot_history_buff{index,1} = test_par_file;
         handles.plot_history_buff{index,2} = test_tr0_file;
         handles.plot_history_buff{index,3} = new_command;

         handles.plot_history_index = index+1;
         handles.plot_history_scroll_index = index;
      else
         index_prev = index - 1;
         while index_prev > 0
         if strcmp(handles.plot_history_buff{index_prev,1},test_par_file) == 1 & strcmp(handles.plot_history_buff{index_prev,2},test_tr0_file) == 1
             break;
         end
             index_prev = index_prev - 1;
         end

         if index_prev == 0
             handles.plot_history_buff{index,1} = test_par_file;
             handles.plot_history_buff{index,2} = test_tr0_file;
             handles.plot_history_buff{index,3} = new_command;
             handles.plot_history_index = index+1;
             handles.plot_history_scroll_index = index;
         elseif strcmp(handles.plot_history_buff{index_prev,3},new_command) ~= 1
             handles.plot_history_buff{index,1} = test_par_file;
             handles.plot_history_buff{index,2} = test_tr0_file;
             handles.plot_history_buff{index,3} = new_command;
             handles.plot_history_index = index+1;
             handles.plot_history_scroll_index = index;
         end
      end

      if index == 430
          for i = 1:400
             handles.plot_history_buff{i,1} = handles.plot_history_buff{i+30,1};
             handles.plot_history_buff{i,2} = handles.plot_history_buff{i+30,2};
             handles.plot_history_buff{i,3} = handles.plot_history_buff{i+30,3};
          end
          index = 400;
          handles.plot_history_index = index+1;
          handles.plot_history_scroll_index = index;
      end
   end


   % Update handles structure
   guidata(hObject, handles);
   %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
   history.radio_test_string = get(handles.radio_test,'String');
   history.radio_test_color = get(handles.radio_test,'ForegroundColor');
   history.radio_test_tr0_string = get(handles.radio_test_tr0,'String');
   history.radio_test_tr0_color = get(handles.radio_test_tr0,'ForegroundColor');
   history.listbox_test_index = handles.listbox_test_index;
   history.listbox_test_tr0_index = handles.listbox_test_tr0_index;
   history.old_num_test_files = handles.old_num_test_files;
   history.old_num_test_tr0_files = handles.old_num_test_tr0_files;

   history.plot_history_buff = handles.plot_history_buff;
   history.plot_history_index = handles.plot_history_index;
   history.plot_history_scroll_index = handles.plot_history_scroll_index;
   history.radio_plot_function = get(handles.radio_plot_function,'String');
   history.plot_functions = handles.plot_functions;
   history.listbox_plot_function_index = handles.listbox_plot_function_index;
   history.plot_linewidth = plot_linewidth;
   filename = sprintf('%s/CppsimView_history.mat',handles.cur_dir);
   save(filename,'history');

end



% --- Executes during object creation, after setting all properties.
function edit_plot_entry_CreateFcn(hObject, eventdata, handles)
% hObject    handle to plot_entry (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc
    set(hObject,'BackgroundColor','white');
else
    set(hObject,'BackgroundColor',get(0,'defaultUicontrolBackgroundColor'));
end

% --------------------------------------------------------------------
function mutual_exclusive(off)
set(off,'Value',0)



% --------------------------------------------------------------------
function save_to_clipboard_menu_Callback(hObject, eventdata, handles)
% hObject    handle to save_to_clipboard_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

error_box('This operation is not currently supported on UNIX','Error using Save to Clipboard');
return;

global plot_axes_handle xzoom_flag

all_figures = get(0,'Children');
if length(all_figures) == 1
    return
end


fig_handles = guihandles(handles.fighandle);
color_order = [0 0 1; 1 0 0; 0 0.5 0; 0 .75 .75; 1 0 1; 0 1 1; .25 .25 .25];
set(fig_handles.figure1,'DefaultAxesColorOrder',color_order);
guidata(handles.fighandle,fig_handles);
axes(plot_axes_handle);
deci_plot(1,1,3);

print(handles.fighandle,'-dbitmap');

mssg_box('Plot Copied to Clipboard','Save To Clipboard Confirmation');


color_order = [1 1 0; 1 0 1; 0 1 1; 1 0 0; 0 1 0; 0 0 1; .75 .75 .75];
set(fig_handles.figure1,'DefaultAxesColorOrder',color_order);
guidata(handles.fighandle,fig_handles);
axes(plot_axes_handle);
deci_plot(1,1,3);



% --------------------------------------------------------------------
function zoom_menu_Callback(hObject, eventdata, handles)
% hObject    handle to zoom_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global plot_axes_handle;
global xzoom_flag;

all_figures = get(0,'Children');
if length(all_figures) == 1
        plot_fig_filename = sprintf('%s/MatlabGui/CppsimView/cppsimview_plot.fig',handles.root_dir);
        handles.fighandle = openfig(plot_fig_filename,'new');
        plot_fig_handles = guihandles(handles.fighandle);
        fHandle = plot_fig_handles.figure1;
        aHandle = plot_fig_handles.axes1;

        set(fHandle,'Visible','on');
        set(fHandle,'HandleVisibility','on');
        set(fHandle,'IntegerHandle','off');
        set(fHandle,'Name','Plot for CppsimView');
        set(fHandle,'NumberTitle','off');
        plot_axes_handle = aHandle;        
        handles.plot_handle = fHandle;        
end

%%%%%%%%%%%%% plot setup %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
set(handles.fighandle,'Color',[0.0 0.0 0.0]);
fig_handles = guihandles(handles.fighandle);
color_order = [1 1 0; 1 0 1; 0 1 1; 1 0 0; 0 1 0; 0 0 1; .75 .75 .75];
set(fig_handles.figure1,'DefaultAxesColorOrder',color_order);
guidata(handles.fighandle,fig_handles);

set(plot_axes_handle,'Color',[0.0 0.0 0.0]);
set(plot_axes_handle,'XColor',[1.0 1.0 1.0]);
set(plot_axes_handle,'YColor',[1.0 1.0 1.0]);
set(plot_axes_handle,'LineWidth',1.5);
axes(plot_axes_handle);
guidata(hObject,handles);

if xzoom_flag == 0
   xzoom_flag = 1;
   out = eval('xzoom','-1');
else
   xzoom_flag = 0;
   out = eval('xzoom(''remove'')','-1');
end

if out == -1
     radio_messages_Callback(hObject, eventdata, handles);
     result_string = sprintf('Error:  %s',lasterr);
     set(handles.listbox_shared,'String',result_string);
     set(handles.listbox_shared,'Value',length(cellstr(result_string)));
     handles.cur_message = result_string;
     % Update handles structure
     guidata(hObject, handles);
end

figure(handles.fighandle);
plot_axes_handle = gca;










% --------------------------------------------------------------------
function save_to_file_menu_Callback(hObject, eventdata, handles)
% hObject    handle to save_to_file_menu (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

global plot_axes_handle xzoom_flag

all_figures = get(0,'Children');
if length(all_figures) == 1
    return
end

[filename,pathname] = uiputfile(...
    {
     '*.eps','Color Postscript (*.eps)'
%     ;'*.epsc','Color Postscript (*.epsc)'
%     ;'*.pdf','PDF (*.pdf)'
    },...
     'Save Plot To File',handles.LastPlotFile);
%  set(handles.figure1,'PaperPositionMode','auto');
%  set(handles.figure1,'InvertHardcopy','off');
%  orient(handles.figure1,'landscape');
% print(handles.figure1,'-depsc','figure.eps')

if filename == 0
   return
end
if length(filename) == 0
   return
end

suffix = strtok(filename,'.');
filename = strcat(filename,'.eps');


if isequal([filename,pathname],[0,0])
   return
else
   File = fullfile(pathname,filename);
   handles.LastPlotFile = File;
   guidata(hObject,handles);
end


fig_handles = guihandles(handles.fighandle);
color_order = [0 0 1; 1 0 0; 0 0.5 0; 0 .75 .75; 1 0 1; 0 1 1; .25 .25 .25];
set(fig_handles.figure1,'DefaultAxesColorOrder',color_order);
guidata(handles.fighandle,fig_handles);
axes(plot_axes_handle);

deci_plot(1,1,3);


print(handles.fighandle,'-depsc',handles.LastPlotFile);

message_string = sprintf('Color EPS file ''%s'' Saved',filename);
mssg_box(message_string,'Save File Confirmation');

color_order = [1 1 0; 1 0 1; 0 1 1; 1 0 0; 0 1 0; 0 0 1; .75 .75 .75];
set(fig_handles.figure1,'DefaultAxesColorOrder',color_order);
guidata(handles.fighandle,fig_handles);
axes(plot_axes_handle);

deci_plot(1,1,3);


function [filename] = get_current_module_filename(netlist,mod_name,lib_name);

filename = {};
fid = fopen(netlist,'r');
if fid < 0
     mssg = sprintf('Error: cannot open netlist file %s\n',netlist);
     uiwait(msgbox(mssg,'Error opening netlist file','modal'));
     close_req_function;
     return
end

while 1
   tline = fgetl(fid);
   if tline ~= -1
      [t,r] = strtok(tline);
      if (strcmp(t,'module:') == 1)
         [cell,r]  = strtok(r);
         library = lower(strtok(r));
         if (strcmp(cell,mod_name) == 1)
             if (length(lib_name) == 0)
                 break;
             elseif (strcmp(library,lib_name) == 1)
                 break;
             end
         end
      end 
   end
   if ~ischar(tline)
      break;
   end
end
tline = fgetl(fid);
if ~ischar(tline)
     mssg = sprintf('Error in get_current_module_filename');
     uiwait(msgbox(mssg,'Error in get_current_module_filename','modal'));
     close_req_function;
     return
else
     [t,r] = strtok(tline);
     if (strcmp(t,'path:') == 1)
        [path] = strtok(r);
        [t,r] = strtok(path,'/');
        filename = strcat('/',t);

        while 1
           [t,r] = strtok(r,'/');
           filename = strcat(filename,'/',t);
           if strcmp(t,mod_name) == 1
              break;
           elseif (length(r) == 0)
              filename = {};
              break;
           end
        end
     end
end

fclose(fid);




function [root_dir_cppsim] = get_root_dir_cppsim(netlist);

root_dir_cppsim = {};
fid = fopen(netlist,'r');
if fid < 0
     mssg = sprintf('Error: cannot open netlist file %s\n',netlist);
     uiwait(msgbox(mssg,'Error in opening netlist file','modal'));
     close_req_function;
     return
end

while 1
   flag = 0;
   tline = fgetl(fid);
   if tline ~= -1
      [t,r] = strtok(tline);
      if (strcmp(t,'path:') == 1)
         r = strtok(r);
         while 1 
             [t,r] = strtok(r,'/');
	     if flag == 0 && strcmp(t,'CppsimShared') == 1
	        flag = 1;
             elseif flag == 1 && strcmp(t,'CadenceLib') == 1                
	        flag = 2;
             elseif flag == 2 && strcmp(t,'CppSimModules') == 1
	        flag = 3;
                break;
             else
                root_dir_cppsim = strcat(root_dir_cppsim,'/',t);
             end
             if length(r) == 0
	        break;
             end
         end
         if flag == 3
	     root_dir_cppsim = strcat(root_dir_cppsim,'/CppsimShared');
	     break;
         else
	     root_dir_cppsim = {};
         end
      end 
   end
   if ~ischar(tline)
      break;
   end
end

fclose(fid);



function [cell,library] = get_current_cell_name(filename);

cell = {};
library = {};
fid = fopen(filename,'r');
if fid < 0
    mssg = sprintf('Error: cannot open netlist file %s\n -> Please Netlist Your Current Cell and then rerun cppsimview',filename);
    uiwait(msgbox(mssg,'Error trying to open netlist file','modal'));
    close_req_function;
    return
end

while 1
   tline = fgetl(fid);
   if tline ~= -1
      [t,r] = strtok(tline);
      if (strcmp(t,'module:') == 1)
         [cell,r]  = strtok(r);
         library = strtok(r);
         break;
      end 
   end
   if ~ischar(tline)
      break;
   end
end
fclose(fid);


function message = get_output_message(filename);

message = {};
fid = fopen(filename,'r');
if fid < 0
   return
end

while 1
   tline = fgetl(fid);
   if tline ~= -1
      if length(message) == 0
         message = tline;
      else
         message = strvcat(message,tline);
      end 
   end
   if ~ischar(tline)
      break;
   end
end
fclose(fid);

%% zip
function result = send_string_list_to_file(string_list,filename);

fid = fopen(filename,'w');
if fid < 0
   result = 0;
   return
end


max_index = length(string_list);


for i=1:max_index
   cur_hier_line = string_list{i};
   fprintf(fid,'%s\n',cur_hier_line);
end

fclose(fid);
result = 1;




function status = check_run_file(cppsim_home,sim_dir,sim_file)

sim_file = strtok(sim_file,'.');
run_command = sprintf('ps -a >! %s/%s_processes.out',sim_dir,...
              sim_file);
[status] = unix(run_command);

processes = cellstr(get_output_message(sprintf('%s/%s_processes.out',sim_dir,sim_file)));

i = strfind(sim_dir,'SimRuns');


ps_key = sprintf('%s/%s',sim_dir(i:length(sim_dir)),sim_file);

status = 0;
for i = 1:length(processes)
     i = strfind(char(processes(i)),ps_key);
     if length(i) > 0
         status = 1;
         break;
     end
end




function date_metric = convert_date_to_metric(date)

[day,r] = strtok(date,'-');
[month,r] = strtok(r,'-');
[year,r] = strtok(r,'- ');
[hour,r] = strtok(r,': ');
[min,r] = strtok(r,': ');
[sec,r] = strtok(r,': ');


switch lower(month)
   case 'jan'
      month_num = '01';
   case 'feb'
      month_num = '02';
   case 'mar'
      month_num = '03';
   case 'apr'
      month_num = '04';
   case 'may'
      month_num = '05';
   case 'jun'
      month_num = '06';
   case 'jul'
      month_num = '07';
   case 'aug'
      month_num = '08';
   case 'sep'
      month_num = '09';
   case 'oct'
      month_num = '10';
   case 'nov'
      month_num = '11';
   case 'dec'
      month_num = '12';
   otherwise
      month_num = '00';
end

date_metric = strcat(year,month_num,day,hour,min,sec);
date_metric = str2num(date_metric);



function status = check_history_file(history)

status = -1;

if isfield(history,'radio_test_string') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if length(strfind(history.radio_test_string,'.par')) == 0 & ...
   strcmp(history.radio_test_string,'New Sim File') == 0
     error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
     return;
end

if length(strfind(history.radio_test_string,'.par')) > 0
   i = strfind(history.radio_test_string,'.par');
   if i+3 ~= length(history.radio_test_string)
     error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
     return;
   end
end

if isfield(history,'radio_test_color') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'radio_test_tr0_string') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if length(strfind(history.radio_test_tr0_string,'.tr')) == 0 & ...
   strcmp(history.radio_test_tr0_string,'No Output File') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'radio_test_tr0_color') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'listbox_test_index') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'listbox_test_tr0_index') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'old_num_test_files') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'old_num_test_tr0_files') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'plot_history_buff') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'plot_history_index') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'plot_history_scroll_index') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'radio_plot_function') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end


if length(strfind(history.radio_plot_function,'(...)')) == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
else
    i = strfind(history.radio_plot_function,'(...)');
    if i+4 ~= length(history.radio_plot_function)
       error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
       return;
    end
end

if isfield(history,'plot_functions') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'listbox_plot_function_index') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

if isfield(history,'plot_linewidth') == 0
    error_box_for_history('History file was corrupted --- starting a new one','History Corrupted');
    return;
end

status = 0;
