%
%   Written by Michael Perrott for viewing CppSim/VppSim output
%   Distribution:  http://www.cppsim.com
%
%   This code is used as part of the CppSimView program
%   (cppsimview.m)
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%


function [] = create_title(title_name)

global plot_title_name title_string

if nargin > 0
   title_string = sprintf('%s for %s',title_name,plot_title_name);
   title_string = cellstr(strrep(title_string,'_','\_'));
end

ax_list = get(gcf,'Children');

max_y = 0.0;
max_i = 1;
for i = 1:length(ax_list)
   if strcmp(get(ax_list(i),'Type'),'axes') == 1
     if strcmp(get(ax_list(i),'YAxisLocation'),'left') == 1 & ...
        strcmp(get(ax_list(i),'Tag'),'legend') == 0
            position = get(ax_list(i),'Position');
            if position(2) > max_y
               max_y = position(2);
               max_i = i;
            end
     end
   end
end

set(get(ax_list(max_i),'Title'),'String',title_string);


