%
%   Written by Michael Perrott for viewing CppSim/VppSim output
%   Distribution:  http://www.cppsim.com
%
%   This code is used as part of the CppSimView program
%   (cppsimview.m)
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function [] = create_xlabel(xlabel_name)

global xlabel_string

if nargin > 0
   xlabel_string = xlabel_name;
end

ax_list = get(gcf,'Children');

min_y = 1.0;
min_i = 1;
for i = 1:length(ax_list)
   if strcmp(get(ax_list(i),'Type'),'axes') == 1
     if strcmp(get(ax_list(i),'YAxisLocation'),'left') == 1 & ...
        strcmp(get(ax_list(i),'Tag'),'legend') == 0
            %%% convert x-axis tick marks to non power of 10 notation
            if strcmp(get(ax_list(i),'XScale'),'log') == 1
                cur_xtick = cellstr(get(ax_list(i),'XTickLabel'));
                new_xtick = zeros(length(cur_xtick),1);
                for k = 1:length(cur_xtick)
                   cur_val = str2num(char(cur_xtick(k)));
                   new_xtick(k) = 10^cur_val;
                end
		set(ax_list(i),'XTickLabel',new_xtick);
            end
            %%% find lower axes
            position = get(ax_list(i),'Position');
            if position(2) < min_y
               min_y = position(2);
               min_i = i;
            end
     end
   end
end
set(get(ax_list(min_i),'XLabel'),'String',xlabel_string);


