%
%   Written by Michael Perrott for viewing CppSim/VppSim output
%   Distribution:  http://www.cppsim.com
%
%   This code is used as part of the CppSimView program
%   (cppsimview.m)
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%


function [] = create_ylabel(ylabel_name)

global ylabel_string fft_flag

if nargin > 0
    ylabel_string = ylabel_name;
end

ax_list = get(gcf,'Children');
count = 0;
for i = 1:length(ax_list)
   if strcmp(get(ax_list(i),'Type'),'axes') == 1
     if strcmp(get(ax_list(i),'YAxisLocation'),'left') == 1 & ...
        strcmp(get(ax_list(i),'Tag'),'legend') == 0
          if fft_flag == 1
             if mod(count,2) == 1
                set(get(ax_list(i),'YLabel'),'String','Magnitude');
             else
                set(get(ax_list(i),'YLabel'),'String','Phase (deg)');
             end
          elseif fft_flag == 2
             if mod(count,2) == 1
                set(get(ax_list(i),'YLabel'),'String','Magnitude (dB)');
             else
                set(get(ax_list(i),'YLabel'),'String','Phase (deg)');
             end
	  else
             set(get(ax_list(i),'YLabel'),'String',ylabel_string);
          end
          count = count + 1;
     end
   end
end

