%
%   Written by Michael Perrott for viewing CppSim/VppSim output
%   Distribution:  http://www.cppsim.com
%
%   This code is used as part of the CppSimView program
%   (cppsimview.m)
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%


function [ysig,legend_string] = create_ysignals_and_legend(x,nodes,subplot_num)

persistent r;
global legend_string_global

delim_m = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ_0123456789@+-/*^().:';

nsp = 1 + sum(nodes == ';');	% number of subplots

if subplot_num == 1
   legend_string_global = cell(nsp,1);
   r = nodes;
   %% separate curves by '?' to avoid confusion with function arg delimiters
   net_paren = 0;
   for i=1:length(r)
      if r(i) == '('
         net_paren = net_paren+1;
      elseif r(i) == ')'
         net_paren = net_paren-1;
      elseif r(i) == ','
         if net_paren == 0
           r(i) = '?';
         end
      end
   end
end

signal_list = [];
legend_string = [];
[t,r] = strtok(r,';');
while length(t) > 0
   [s,t] = strtok(t,'?');
   if length(s) > 0
       signal_list = [signal_list, cellstr(s)];
       legend_string = [legend_string, cellstr(strrep(s,'_','\_'))];
   end
   [s,t] = strtok(t,delim_m);
end

legend_string_global{subplot_num} = legend_string;

ysig = evalsig(x, char(signal_list(1)));
if length(ysig) == 0
    return;
end

for i = 2:length(signal_list)
  next_sig = evalsig(x, char(signal_list(i)));
  if length(next_sig) == 0
      ysig = [];
      return;
  end
  ysig = [ysig, next_sig];
end
