%
%   Written by Michael Perrott for viewing CppSim/VppSim output
%   Distribution:  http://www.cppsim.com
%
%   This code is used as part of the CppSimView program
%   (cppsimview.m)
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function [phase,avg_period] = extract_phase(raw_period_seq,raw_period_seq_ref)


count = 0;
for i = 1:length(raw_period_seq)
   if (raw_period_seq(i) ~= 0.0)
     count = count + 1;
   end
end

if count < 3
   phase = 0;
   avg_period = 1;
   return
end

period_seq = zeros(count,1);

k = 1;
for i = 1:length(raw_period_seq)
   if (raw_period_seq(i) ~= 0.0)
      period_seq(k) = raw_period_seq(i);
      k = k + 1;
   end
end


if (nargin == 2)

   period_seq2 = zeros(count,1);

   k = 1;
   for i = 1:length(raw_period_seq_ref)
      if (raw_period_seq_ref(i) ~= 0.0)
         period_seq2(k) = raw_period_seq_ref(i);
         k = k + 1;
         if (k > count)
           break;
         end
      end
   end

   if (k <= count)
     period_seq = period_seq(1:k-1);
     period_seq2 = period_seq2(1:k-1);
   end

   min_period = min(period_seq2(3:length(period_seq2)));
   normalized_period = zeros(length(period_seq2)-1,1);
   for i = 1:length(normalized_period)
      val = period_seq2(1+i);
      count = 1;
      while (val > min_period*1.5)
         val = val - min_period;
         count = count + 1;
      end
      normalized_period(i) = period_seq2(1+i)/count;
   end

%   avg_period = mean(period_seq2(2:length(period_seq2)));
   avg_period = mean(normalized_period);
   phase_orig = filter(1,[1 -1],period_seq-period_seq2)/avg_period;
else
   avg_period = mean(period_seq(2:length(period_seq)));
   phase_orig = filter(1,[1 -1],period_seq-avg_period)/avg_period;
end

phase = phase_orig(1:(length(phase_orig)-3));

