%
%   Written by Michael Perrott for viewing CppSim/VppSim output
%   Distribution:  http://www.cppsim.com
%
%   This code is used as part of the CppSimView program
%   (cppsimview.m)
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function [t] = form_x_eye_vector(t_in,period,time_offset)

ind = find(t_in >= time_offset);

if length(ind) > 0
   start_i = ind(1);
else
   start_i = 1;
end

Ts = t_in(20)-t_in(19);
period_samples = round(period/Ts);
time_vector = Ts*(0:period_samples-1);

total_samples = length(t_in) - start_i + 1;
num_frames = floor(total_samples/period_samples);
span_samples = period_samples*num_frames;

t = zeros(span_samples,1);

cur_i = 1;
for i = 1:num_frames
   for j = 1:period_samples
      t_offset = (i-1)*period_samples;
      if mod(i,2) == 1
         t(cur_i) = time_vector(j);
      else
         t(cur_i) = time_vector(period_samples-j+1);
      end
      cur_i = cur_i + 1;
   end
end
