%
%   Written by Michael Perrott for viewing CppSim/VppSim output
%   Distribution:  http://www.cppsim.com
%
%   This code is used as part of the CppSimView program
%   (cppsimview.m)
%
%   For those that use this code - please
%   keep my name attached to it (as currently done).  
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published by
% the free Software Foundation; either version 2 of the License, or
% (at your option) any later version.
%
% This program is distributed in the hope that it will be useful,
% but WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
% GNU General Public License for more details.
%
% You should have received a copy of the GNU Library General Public
% License along with this library; if not, write to the MxFree
% Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
%

function [rise_cr,fall_cr] = tr_times(time,data,rise_thresh,fall_thresh)

rise_count = 1;
fall_count = 1;
for i = 2:length(data)
   if (data(i) > rise_thresh & data(i-1) <= rise_thresh)
      rise_count = rise_count + 1;
   end
   if (data(i) < fall_thresh & data(i-1) >= fall_thresh)
      fall_count = fall_count + 1;
   end
end

rise_cr = zeros(rise_count,1);
fall_cr = zeros(fall_count,1);

rise_count = 1;
fall_count = 1;

for i = 2:length(data)
   if (data(i) > rise_thresh & data(i-1) <= rise_thresh)
      interp_time = time(i) + (rise_thresh - data(i))*(time(i)-time(i-1))/(data(i)-data(i-1));
      rise_cr(rise_count) = interp_time;
      rise_count = rise_count + 1;
   end
   if (data(i) < fall_thresh & data(i-1) >= fall_thresh)
      interp_time = time(i) + (fall_thresh - data(i))*(time(i)-time(i-1))/(data(i)-data(i-1));
      fall_cr(fall_count) = interp_time;
      fall_count = fall_count + 1;
   end
end

