#### Procedures for Local Documentation viewing

# Open Custom Designer Platform User Guide (PDF)

proc local_doc_open_custom_designer_platform_user_guide {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob custom_designer_platform_user_guide -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/plug.pdf" -runDesc "Custom Designer Platform User Guide"
}

# Open Custom Designer Schematic User Guide (PDF)

proc local_doc_open_custom_designer_schematic_user_guide {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob custom_designer_schematic_user_guide -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/seuser.pdf" -runDesc "Custom Designer Schematic User Guide"
}

# Open Custom Designer Schematic Driven Layout User Guide (PDF)

proc local_doc_open_custom_designer_schematic_driven_layout_user_guide {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob custom_designer_schematic_driven_layout_user_guide -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/sdluser.pdf" -runDesc "Custom Designer Schematic Driven Layout User Guide"
}

# Open Custom Designer Layout User Guide (PDF)

proc local_doc_open_custom_designer_layout_user_guide {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob custom_designer_layout_user_guide -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/leuser.pdf" -runDesc "Custom Designer Layout User Guide"
}

# Open Hspice Documentation (HTML)

proc local_doc_open_hspice_documentation_html {schematic_wt} {

if {[auto_execok hspice] == ""} {
   hspc_error_dialog "Error: Hspice command not found!" $schematic_wt
   puts "Error:  hspice command not found!"
   puts "      -> make sure that you have installed Hspice and"
   puts "         included it in your path"
   puts "--- Error: opening hspice documentation failed ---"
   return
}
xt::createJob hspice_doc_html -type batch -cmdLine "hspice -help" -runDesc "Hspice Documentation (HTML)"
}

# Open Hspice Documentation (PDF)

proc local_doc_open_hspice_documentation_pdf {schematic_wt} {

if {[auto_execok hspice] == ""} {
   hspc_error_dialog "Error: Hspice command not found!" $schematic_wt
   puts "Error:  hspice command not found!"
   puts "      -> make sure that you have installed Hspice and"
   puts "         included it in your path"
   puts "--- Error: opening hspice documentation failed ---"
   return
}
xt::createJob hspice_doc_pdf -type batch -cmdLine "hspice -doc" -runDesc "Hspice Documentation (PDF)"
}

# Open Hspice MOSFET Parameter Names for .probe (PDF)

proc local_doc_open_hspice_mosfet_parameter_names_pdf {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob hspc_doc -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/hspice_mosmod.pdf" -runDesc "Hspice MOSFET Parameter Names for .probe (PDF)"
}

# Open HSPC Manual (PDF)

proc local_doc_open_hspc_manual {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob hspc_doc -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/hspc.pdf" -runDesc "HSPC Manual (PDF)"
}

# Open SAE User Manual (PDF)

proc local_doc_open_sae_user_manual {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob sae_doc -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/sae_user.pdf" -runDesc "SAE User Manual (PDF)"
}

# Open TCL Reference Manual (PDF)

proc local_doc_open_tcl_ref_manual {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob tcl_doc -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/tclref.pdf" -runDesc "TCL Reference Manual (PDF)"
}

# Open Custom WaveView Manual (PDF)

proc local_doc_open_custom_waveview_manual {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob custom_waveview_doc -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/wvug.pdf" -runDesc "Custom WaveView User Manual (PDF)"
}

# Open Custom WaveView Quick Reference (PDF)

proc local_doc_open_custom_waveview_quick_ref {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob custom_waveview_quick_ref -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/qref.pdf" -runDesc "Custom WaveView Quick Reference (PDF)"
}

proc local_doc_open_tsmc_180nm_pdk_usage_guide {schematic_wt} {

xt::createJob tsmc_180nm_pdk_usage -type batch -cmdLine "evince ~/Synopsys/ipdk_tsmc180nm/PDK_doc/TSMC_DOC_WM/PDK/CR018_GPII_CDF_Usage.pdf" -runDesc "TSMC 180nm PDK Usage Guide (PDF)"
}

proc local_doc_open_tsmc_180nm_noise_data {schematic_wt} {

xt::createJob tsmc_180nm_noise_data -type batch -cmdLine "evince ~/Synopsys/ipdk_tsmc180nm/PDK_doc/TSMC_DOC_WM/NoiseData/T018LOSP003_14.PDF" -runDesc "TSMC 180nm 1/f Noise Data (PDF)"
}

proc local_doc_open_hspice_toolbox_for_matlab_manual {schematic_wt} {
global CPPSIMSHARED_HOME

xt::createJob hspice_toolbox_for_matlab -type batch -cmdLine "evince $CPPSIMSHARED_HOME/Tcl/LocalDoc/hspice_toolbox.pdf" -runDesc "Hspice Toolbox for Matlab Documentation"
}

proc local_doc_open_tsmc18_deep_nwell {schematic_wt} {

xt::createJob tsmc18_deep_nwell -type batch -cmdLine "evince ~/Synopsys/ipdk_tsmc180nm/Extra_TSMC_Docs/tsmc18_deep_nwell.pdf" -runDesc "Information on TSMC18 Deep Nwell Devices"
}

proc local_doc_open_gen_tsmc18_design_rules {schematic_wt} {

xt::createJob tsmc18_gen_design_rules -type batch -cmdLine "evince ~/Synopsys/ipdk_tsmc180nm/Extra_TSMC_Docs/T018LODR001_2_8.pdf" -runDesc "General TSMC18 Design Rules"
}

proc local_doc_open_tsmc18_design_rules {schematic_wt} {

xt::createJob tsmc18_design_rules -type batch -cmdLine "evince ~/Synopsys/ipdk_tsmc180nm/Extra_TSMC_Docs/T018CMDR006_1_0.pdf" -runDesc "Mixed-Signal TSMC18 Design Rules"
}
